#define _CRT_SECURE_NO_DEPRECATE
#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <map>
#include <set>


using namespace std;
using ll = long long;

map<char, int> char2int;

vector<vector<double> > mostLikely(const string& R) {
	vector<vector<double> > res(10, vector<double>(10));
	int order[] = { 1, 0, 2, 3, 4, 5, 6, 7, 8, 9 };
	int i = 0;
	set<char> used;
	used.insert(R[0]);
	for (int q = 1; q < 10; q++) {
		res[char2int[R[0]]][q] = -2*pow(10, R.size()) * log(q*pow(10, R.size() - 1));
	}
	int w = R.size() - 1;
	for (auto c : R.substr(1)) {
		if (used.count(c) == 0) {
			for (int q = 0; q < 10; q++) {
				res[char2int[c]][q] = -2*pow(10, w) * log(q * pow(10, w - 1));
			}
		}
		w--;
	}
	return res;
}


string getD(const vector<vector<double> >& cnt,
			const string& int2char) {
	double dp[1024][11]{};
	int p[1024][11]{};
	for (int i = 0; i < 10; i++) {
		for (int mask = 0; mask < 1024; mask++) {
			for (int j = 0; j < 10; j++) {
				if (((mask >> j) & 1) == 0) {
					auto nextMask = mask | (1 << j);
					if (dp[nextMask][i + 1] < dp[mask][i] + cnt[j][i]) {
						dp[nextMask][i + 1] = dp[mask][i] + cnt[j][i];
						p[nextMask][i + 1] = j;
					}
				}
			}
		}
	}
	string D;
	int mask = 1023;
	for (int i = 10; i > 0; i--) {
		int j = p[mask][i];
		mask ^= (1 << j);
		D.push_back(int2char[j]);
	}
	reverse(D.begin(), D.end());
	//cout << dp[1023][10] << '\n';
	return D;
}


void solve() {
	int u;
	cin >> u;
	/*if (u == 2) {
		cout << "TPFOXLUSHB\n";
		return;
	}*/
	set<char> Dset;
	vector<string> Rs;
	for (int i = 0; i < 10000; i++) {
		ll Q;
		string R;
		cin >> Q >> R;
		Dset.insert(R.begin(), R.end());
		Rs.emplace_back(move(R));
	}
	char2int.clear();
	int i = 0;
	for (auto x : Dset) {
		char2int[x] = i++;
	}
	vector<vector<double> > cnt(10, vector<double>(10));
	for (auto& R : Rs) {
		auto ml = mostLikely(R);
		for (int i = 0; i < 10; i++) {
			for (int j = 0; j < 10; j++) {
				cnt[i][j] += ml[i][j];
			}
		}
	}
	string int2char(Dset.begin(), Dset.end());
	auto D = getD(cnt, int2char);
	cout << D << '\n';
	/*for (auto& row : cnt) {
		for (auto q : row) {
			cout << q << ' ';
		} 
		cout << '\n';
	}*/
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // _DEBUG
	ll t;
	cin >> t; // >> a >> b;
	for (int i = 1; i <= t; i++) {
		cout << "Case #" << i << ": ";
		solve();
	}
}