// 2020 @abel0b

#include <bits/stdc++.h>

#ifdef DEBUG
#include "debug.h"
#else
#ifdef __GCC__
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#endif
#define check(...) 1337
#define debug(...) 1337
#endif

using namespace std;

template<typename T>
using vec = vector<T>;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<long long, long long>;

#define fi first
#define se second

//mt19937 mt19937(0xbeef);

int pw(int x, int p) {
  if (p == 0) return 1;
  if (p == 1) return x;

  int tmp = pw(x, p/2);
  if (p%2 == 0) return tmp * tmp;
  else return x * tmp * tmp;
}

struct blem {
    int case_num;

    // Problem
    int up;
    vec<pair<int,string>> data;

    // Solution
    string secret = "0000000000";
    string all;

    blem(int case_num, istream& is): case_num(case_num) {
        is >> up;
        for (int i = 0; i < 10e4; ++i) {
            int q;
            string n;
            is >> q >> n;
            data.emplace_back(q, n);
            if ((int)all.size() < 10) {
                for(auto cc: n) {
                    if (all.find(cc) == string::npos) {
                        all.push_back(cc);
                    }
                }
            }
        }
        assert(data.size() == 10e4);
        sort(data.begin(), data.end(), [](const pair<int,string>& p1, const pair<int,string>& p2) {
            return p1.fi < p2.fi;
        });
    }

    void solve() {
        int i = 0;
        int found = 0;

        while(i<=(int)data.size()) {
            int p = data[i].fi;
            string n = data[i].se;
            if (p>10) break;
            if (p == -1) p = pw(10, up)-1;    
            int un = 0;
            int unp;
            string vis;
            
            int newp = p;
            string newn;
            bool inbeg = true;
            for(int tt=0;tt<(int)n.size(); tt++) {
                if (inbeg) {
                    if (secret.find(n[tt]) != string::npos) {
                        newp = newp - newp/pw(10, n.size()-tt-1);
                        inbeg = false;
                    }
                    else {
                        break;
                    }
                }
                else {
                    newn = newn + n[tt];
                }
            }

            if (newn.size()) {
                p = newp;
                n = newn;
            }
            else {
                newp = p;
                inbeg = true;
                newn = "";
                for(int tt=n.size()-1;tt>=0; tt--) {
                    if (inbeg) {
                        if (secret.find(n[tt]) != string::npos) {
                            int pd = pw(10, n.size()-tt);
                            newp = (newp/pd)*pd;
                            inbeg = false;
                        }
                        else {
                            break;
                        }
                    }
                    else {
                        newn = n[tt] + newn;
                    }
                }
                if (newn.size()) {
                    p = newp;
                    n = newn;
                }
            }

            for (int kk=0; kk<(int)n.size(); kk++) {
                char cc = n[kk];
                if (secret.find(cc) == string::npos && vis.find(cc) == string::npos) {
                    un++;
                    unp = kk;
                    vis.push_back(cc);
                }
            }
            if (un == 1) {
                found ++;
                int pd = pw(10, n.size()-unp-1);
                int pd1 = pw(10, n.size()-unp);
                int digit = p - p%pd;
                digit = digit - (digit/pd1)*pd1;
                assert(digit>=0);
                assert(digit<10);
                debug(n[unp]);
                secret[digit] = n[unp];
            }
            if (found == 9) break;
            i++;
        }
    
        if (found == 9) { 
            for(int nn=0; nn < (int)secret.size(); nn++) {
                if (secret[nn] == '0') {
                    for (int ii=0; ii<(int)all.size(); ii++) {
                        if (secret.find(all[ii]) == string::npos) {
                            secret[nn] = all[ii];
                        }
                    } 
                    break;
                }
            }
        }
    }

    void write(ostream& os) {
        os << "Case #" << case_num << ": ";
        os << secret;
        os << "\n";
    }
};

int main() {
#ifndef DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cerr.tie(nullptr);
#endif

    istream& input = cin;
    ostream& output = cout;

    int num_cases;
    cin >> num_cases;

    for(int case_num=1; case_num<=num_cases; ++case_num) {
        blem test_case(case_num, input);
        test_case.solve();
        test_case.write(output);
    }

    return 0;
}
