#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <assert.h>
#include <fstream>
#include <cstdlib>
#include <random>
#include <iomanip>
#include <bitset>
 
using namespace std;
 
#define sqr(a) ((a)*(a))
#define all(a) (a).begin(), (a).end()
 
const int MOD = (int) 998244353;
const int MAX_N = (int) 100;

void solve() {
    int n;
    cin >> n;

    map<char, vector<bool> > q;
    map<char, int> w;

    bool kek = false;
    for (int it = 0; it < (int) 1e4; ++it) {
        long long a;
        string b;
        cin >> a >> b;

        for (char c : b) {
            if (q.find(c) == q.end())
                q[c] = vector<bool>(10, true);
        }

        q[b[0]][0] = 0;

        ++w[b[0]];

        if (a == -1) {
            kek = true;
            continue;
        }

        if (b.size() == to_string(a).size()) {
            while (a > 9)
                a /= 10;

            auto& temp = q[b[0]];

            for (int j = a + 1; j < 10; ++j)
                temp[j] = 0;
        }
    }

    kek = true;

    if (kek) {
        vector<pair<int, char> > ans;
        for (auto i : w) {
            ans.push_back({i.second, i.first});
        }
        sort(all(ans));
        reverse(all(ans));

        for (auto i : q) {
            bool find = false;
            for (auto j : ans)
                if (j.second == i.first) {
                    find = true;
                    break;
                }

            if (!find) {
                cout << i.first;
                break; 
            }
        }

        for (auto i : ans)
            cout << i.second;
        cout << "\n";
    } else {
        string ans = "??????????";

        for (auto i : q) {
            int sum = 0;
            for (auto j : i.second)
                sum += j;

            ans[sum % 10] = i.first;
        }

        cout << ans << "\n";
    }
}

// void gen() {
//     std::random_device rd;

//     std::mt19937_64 e2(rd());

//     for (int i = 0; i < 10; ++i) {
//         cout << rand() << "\n";
//     }
// }

int main() {
    // freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    srand(time(0));

    // gen();

    int tests;
    cin >> tests;

    for (int it = 1; it <= tests; ++it) {
        cout << "Case #" << it << ": ";

        solve();
    }
}