#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

void check(string s1, string s2, vector<vector<int>> &v) {
    if (s1.size() > s2.size()) {
        if (s2.size() == 1) {
            char c = s2[0];
            v[c - 'A'][0] = 0;
        }
        return;
    }
    // s2[0] only from 1 to s1[0]
    v[s2[0] - 'A'][0] = 0;
    for (int i = s1[0] - '0' + 1; i < 10; ++i) {
        v[s2[0] - 'A'][i] = 0;
    }
    // s2[1] onwards coule be anything
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int T; cin >> T;
    for (int cse = 1; cse <= T; ++cse) {
       int U; cin >> U;
    
       map<char, bool> seen;

       vector<vector<int>> v(26, vector<int>(10, 1));
       for (int i = 0; i < 10000; ++i) {
            string s1, s2; cin >> s1 >> s2;
            for (auto c : s2) seen[c] = true;
            if (s1 == "-1") continue;
            check(s1, s2, v);
       }

       vector<pair<int,int>> order;
       for (int i = 0; i < 26; ++i) {
            int sum = 0;
            for (int j = 0; j < 10; ++j) {
                if (v[i][j]) sum++;
            }
            order.push_back({sum, i});
       }

       sort(order.begin(), order.end());
       vector<char> ans(10, '?');

 //      for (auto x : order) cout << x.first << " " << x.second <<"\n";

       
       map<char, bool> inans;


       for (int i = 0; i < 26; ++i) {
            for (int j = 0; j < 10; ++j) {
                if (v[order[i].second][j]) {
                    if (ans[j] == '?') {
                        char tmp = (char) (order[i].second + 'A');
                        if (seen[tmp]) {
                            ans[j] = tmp;
                            inans[tmp] = true;
                            break;
                        }
                    }
                }
            }
       }

//       for (int i = 0; i < 10; ++i) ans[i] = '?';

       for (int i = 0; i < 26; ++i) {
            for (int j = 0; j < 10; ++j) {
                if (v[order[i].second][j]) {
                    if (ans[j] == '?') {
                        char tmp = (char) (order[i].second + 'A');
                        if (!inans[tmp]) {
                            ans[j] = tmp;
                            break;
                        }
                    }
                }
            }
       }

 
       for (int i = 0; i < 26; ++i) {
            for (int j = 0; j < 10; ++j) {
                if (v[order[i].second][j]) {
                    if (ans[j] == '?') {
                        char tmp = (char) (order[i].second + 'A');
                        ans[j] = tmp;
                        break;
                    }
                }
            }
       }

   
        cout << "Case #" << cse << ": ";
        for (int i = 0; i < 10; ++i) {
            cout << ans[i];
        }
        cout << "\n";
    }

    return 0;
}
