#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <tuple>

using namespace std;

void setLetter(vector<set<int>>& possibles, char c, int d) {
	for (char c2 = 'A'; c2 <= 'Z'; ++c2) {
		if (c2 == c) continue;
		auto it = possibles[c2].find(d);
		if (it != possibles[c2].end()) {
			possibles[c2].erase(it);
			if (possibles[c2].size() == 1) {
				setLetter(possibles, c2, *(possibles[c2].begin()));
			}
		}
	}
}

string encBack(vector<char>& tr, string& s, char zero) {
	string ret(s);
	for (auto& c : ret) c = tr[c];
	while (!ret.empty() && ret[0] == zero) ret.erase(ret.begin());
	return ret;
}

bool ok(string& ret, vector<pair<string, string>>& in) {
	string Q, R;
	vector<char> tr('Z'+1);
	for (int i = 0; i < 10; ++i) tr[ret[i]] = i+'0';
	for (auto& p : in) {
		std::tie(Q, R) = p;
		if (ret[0] == R[0]) return false;
		string e = encBack(tr, R, ret[0]);
		if (e.empty()) return false;
		if (e.length() < Q.length()) continue;
		if (e.length() > Q.length()) return false;
		if (e <= Q) continue;
		//cerr << ret << " " << Q << " " << R << " " << e << endl;
		return false;
	}
	return true;
}

int main() {
	int T;
	cin >> T;
	for (int q = 1; q <= T; ++q) {
		int U;
		cin >> U;
		//long long upper = (U == 2 ? 99 : 9999999999999999ll);
		vector<pair<string, string>> in(10000);
		vector<set<int>> possibles('Z' + 1);
		string Q, R;
		for (int i = 0; i < in.size(); ++i) {
			cin >> Q >> R;
			if (Q == "-1") Q = "9999999999999999";
			in[i] = make_pair(Q, R);
			for(auto& c : R) if (possibles[c].size() == 0) for (int i = 0; i <= 9; ++i) possibles[c].insert(i);
			
			char c = R[0];
			auto it = possibles[c].find(0);
			if (it != possibles[c].end()) {
				possibles[c].erase(it);
			}
		}

		set<char> lettersUsed;
		for (auto& p : in) {
			std::tie(Q, R) = p;
			for (char c : R) lettersUsed.insert(c);
		}
		string ret(lettersUsed.begin(), lettersUsed.end());
		int tried = 0;
		//ret = "TPFOXLUSHB";
		while (1) {
			//if (++tried % 1000 == 0) cerr << ret << endl;
			if (ok(ret, in)) break;
			/*if (ret == "TPFOXLUSHB") {
				cerr << "dupa" << endl;
				exit(1);
			}*/
			next_permutation(ret.begin(), ret.end());
		}

		//set<char> zeros;
		//for (char c2 = 'A'; c2 <= 'Z'; ++c2) {
		//	if (possibles[c2].find(0) != possibles[c2].end()) zeros.insert(c2);
		//}
		//if (zeros.size() == 1) {
		//	char c = *zeros.begin();
		//	possibles[c].clear();
		//	possibles[c].insert(0);
		//}

		//for (auto& p : in) {
		//	std::tie(Q, R) = p;
		//	char one = 'x';
		//	while (Q.size() > 0 && Q.length() == R.size() && Q[0] == '1') {
		//		char c = R[0];
		//		int v = 1;
		//		if (one == 'x' || one == c) one = c;
		//		else v = 0;
		//		possibles[c].clear();
		//		possibles[c].insert(v);
		//		setLetter(possibles, c, v);
		//		Q.erase(Q.begin());
		//		R.erase(R.begin());
		//		while (!Q.empty() && Q[0] == '0') {
		//			c = R[0];
		//			possibles[c].clear();
		//			possibles[c].insert(0);
		//			setLetter(possibles, c, 0);
		//			Q.erase(Q.begin());
		//			R.erase(R.begin());
		//		}
		//		break;
		//	}
		//	if (Q.empty()) continue;
		//	if (Q.length() == 1) {
		//		int d = Q[0] - '0';
		//		char c = R[0];
		//		for (int p = d + 1; p <= 9; ++p) {
		//			auto it = possibles[c].find(p);
		//			if (it != possibles[c].end()) {
		//				possibles[c].erase(it);
		//				if (possibles[c].size() == 1) {
		//					setLetter(possibles, c, *(possibles[c].begin()));
		//				}
		//			}
		//		}
		//	}
		//}


		//string ret(10, ' ');
		//for (char c = 'A'; c <= 'Z'; ++c) {
		//	if (possibles[c].size() == 1) 
		//		ret[*(possibles[c].begin())] = c;
		//}

		cout << "Case #" << q << ": " << ret << endl;

		//for (char c = 'A'; c <= 'Z'; ++c) {
		//	cout << c << ": " << possibles[c].size() << "(";
		//	for (auto& t : possibles[c]) cout << t << " ";
		//	cout << ")" << endl;
		//}
	}
	return 0;
}