#include<algorithm>
#include<functional> // for hash
#include<climits> // all useful constants
#include<cmath>
#include<chrono>
#include<cstdio>
#include<cstdlib> // random
#include<ctime>
#include<iostream>
#include<fstream>
#include<sstream>
#include<iomanip> // right justifying std::right and std::setw(width) /*** Data Structure ***/
#include<deque> // double ended queue
#include<list>
#include<queue> // including priority_queue
#include<stack>
#include<string>
#include<vector>
#include<map>
#include<set>
using namespace std;

int INTMAX = numeric_limits<int>::max();
int INTMIN = numeric_limits<int>::min();
size_t SIZETMAX = numeric_limits<size_t>::max();
typedef long long int l_int;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;
typedef vector<bool> vb;
typedef vector<vector<bool>> vvb;
typedef vector<string> vs;
typedef vector<vector<string>> vvs;
typedef vector<l_int> vl;
typedef vector<vector<l_int>> vvl;
typedef map<int,int> mii;
typedef set<int> si;
typedef map<l_int,l_int> mll;
typedef set<l_int> sl;

#define abs(a) ((a)<0?-(a):(a))
#define mid(a, b) ((1ll*(a)+(b))/2)
#define Max(a, b) ((a)>(b)?(a):(b))
#define Min(a, b) ((a)<(b)?(a):(b))
#define maxans(ans, b) (ans = ((ans==-1 || ans<(b))?(b):ans))
#define minans(ans, b) (ans = ((ans==-1 || ans>(b))?(b):ans))
#define sq(a) (1ll*(a)*(a))
#define mod(a,m) (((a)%(m)+(m))%(m))
#define plusmod(a,b,m) ((1ll*(a)+(b))%(m))
#define minusmod(a,b,m) (mod((1ll*(a)-(b)), (m)))
#define multmod(a,b,m) ((((1ll*(a))%(m))*((1ll*(b))%(m)))%(m))
#define invmod(a,m) (powmod(a,m-2,m))
#define divmod(a,b,m) (multmod(a, invmod(b,m), m))

template<class T>
T gcd(T a, T b){return b?gcd<T>(b,a%b):a;};
template<class T>
T lcm(T a, T b){return a*b/gcd<T>(a,b);};
int powmod(int a,int b, int m){
  if(m == 1) return 0;
  else if(m < 1) return 0;
  else if(b == 1) return mod(a, m);
  else if(b < 1) return mod(1, m);
  int ans = 1;
  a = mod(a, m);
  while(b > 0){
    if(b&1) ans = multmod(ans, a, m);
    b >>= 1;
    a = multmod(a, a, m);
  }
  return ans;
};

//random hashing begin
struct hash_splitmix64 {
    static uint64_t splitmix64(uint64_t x) {
        // http://xorshift.di.unimi.it/splitmix64.c
        x += 0x9e3779b97f4a7c15; x = (x ^ (x >> 30)) * 0xbf58476d1ce4e5b9; x = (x ^ (x >> 27)) * 0x94d049bb133111eb;
        return x ^ (x >> 31);
    }
    size_t operator()(uint64_t x) const {
        static const uint64_t FIXED_RANDOM = chrono::steady_clock::now().time_since_epoch().count();
        return splitmix64(x + FIXED_RANDOM);
    }
};
#include<unordered_map>
#include<unordered_set>
template<typename Key, typename Value>
using u_map = std::unordered_map<Key, Value, hash_splitmix64>;
template<typename Key>
using u_set = std::unordered_set<Key, hash_splitmix64>;
//random hashing end

template<class T>
size_t upb(vector<T>& arr, T v, size_t beg=0, size_t end=SIZETMAX){//find_first_greater (ascending)
  size_t p = (beg+end)/2;
  if(arr[beg] > v || beg >= end) return beg;
  while(beg+1 < end){
    if(arr[p] > v) end = p;
    else beg = p;
    p=(beg+end)/2;
  }
  return end;
}
template<class T>
size_t lwb(vector<T>& arr, T v, size_t beg=0, size_t end=SIZETMAX){//find_first_non_smaller (ascending)
  size_t p = (beg+end)/2;
  if(arr[beg] >= v || beg >= end) return beg;
  while(beg+1 < end){
    if(arr[p] >= v) end = p;
    else beg = p;
    p=(beg+end)/2;
  }
  return end;
}

int _=1, __, MOD=998244353;
int main(){
for(cin >> __;__>0;__--){
    int n = 10000, u; cin >> u;
    string s, ans, lans;
    int Mi;
    map<string, int> sm;
    map<string, int> cnt;
    vector<l_int> ccnt(26, 0);
    vector<l_int> ccnt2(26, 0);
    vector<bool> included(26, false);
    vector<bool> cant(26, false);
    vs cand;
    int w = 10;
    for(int i=0;i<n;i++){
      cin >> Mi >> s;
      // for(char ch: s) ccnt[ch-'A']++;
      for(int j=0;j<s.size();j++){
        ccnt[s[s.size()-1-j]-'A'] += (u-j)*w;
        ccnt2[s[j]-'A']++;
      }
      // cant[s[0]-'A'] = true;
      // if(sm.count(s)) sm[s] = Min(sm[s], Mi);
      // else{sm[s] = Mi; cand.push_back(s);}
      // cnt[s]++;
    }
    // auto cmp = [&cnt](string& a, string& b){return cnt[a] > cnt[b];};
    // sort(cand.begin(), cand.end(), cmp);
    // for(int i=0;i<cand.size();i++){
    //   if(cand[i].size() == 1){
    //     lans += cand[i][0];
    //     included[cand[i][0]-'A'] = true;
    //   }
      // if(cand[i].size() <= 2){printf("%s: %d\n", cand[i].c_str(), cnt[cand[i]]);}
    // }
    // for(int i=0;i<26;i++){
    //   if(ccnt[i] > 0 && !included[i]){
    //     if(cant[i]) lans += char('A'+i);
    //     else ans += char('A'+i);
    //   }
    // }
    vi freq, freq2;
    for(int i=0;i<26;i++){freq.push_back(i);freq2.push_back(i);}
    sort(freq.begin(), freq.end(), [&ccnt](int i,int j){return ccnt[i] > ccnt[j];});
    sort(freq2.begin(), freq2.end(), [&ccnt2](int i,int j){return ccnt2[i] > ccnt2[j];});
    cout << "Case #"<< _++ <<": " << char('A'+freq2[9]);
    for(int i=0;i<10;i++) if(freq2[9] != freq[i])cout<< char('A'+freq[i]);
    cout<<endl;
    // cout << "Case #"<< _++ <<": " << ans << lans << endl;
  }
  return 0;
}
