

#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <set>
#include <algorithm>
#include <sstream>
#include <iostream>
#include <cassert>
#include <fstream>
#include <chrono>
#include <iomanip>
#include <numeric>
#include <random>

using namespace std;
//typedef int64_t int64;
typedef long long int int64;
#define all(x) (x).begin(), (x).end()

template<typename T>
T nextValue(std::istream &in) {
    T i;
    in >> i;
    return i;
}

template<typename T>
std::vector<T> readVector(std::istream &in, int n) {
    std::vector<T> c;
    std::generate_n(std::back_inserter(c), n, [&in]() { return nextValue<T>(in); });
    return c;
}

static int64 gcd(int64 a, int64 b) {
    if (a < 0 || b < 0)
        return -1;
    while (b != 0) {
        int64 x = a % b;
        a = b;
        b = x;
    }
    return a;
}


static void solve() {
    int u = nextValue<int>(cin);
    int64 mm = int64(pow(10, u)) - 1;
    bool unknown = false;
    int n = 10000;
    std::vector<int64> qi(n);
    std::vector<std::string> qq(n);
    std::vector<std::string> rr(n);
    for (int i = 0; i < n; ++i) {
        qi[i] = nextValue<int64>(cin);
        if (qi[i] < 0) {
            unknown = true;
            qi[i] = mm;
        }
        qq[i] = std::to_string(qi[i]);
        rr[i] = nextValue<std::string>(cin);
    }
    std::set<char> all;
    std::set<char> allFirst;
    for (int i = 0; i < n; ++i) {
        allFirst.insert(rr[i][0]);
        for (auto c : rr[i])
            all.insert(c);
        if (all.size() == 10 && allFirst.size() == 9)
            break;
    }
    std::string digits = "0123456789";
    std::map<char, int> hi;
    for (auto c : all) {
        hi[c] = 9;
        if (allFirst.find(c) == allFirst.end()) {
            digits[0] = c;
            hi[c] = 0;
        }
    }
    if (unknown) {
        std::map<char, int> countFirst;
        for (int i = 0; i < n; ++i) {
            countFirst[rr[i][0]]++;
        }
        std::vector<std::pair<int, char>> cc;
        for (auto const & kv : countFirst) {
            cc.emplace_back(kv.second, kv.first);
        }
        std::sort(cc.begin(), cc.end(), greater<std::pair<int, char>>());
        for (int i = 1; i < 10; i++) {
            digits[i] = cc[i - 1].second;
        }
        cout << digits;
        return;
    }

    for (int i = 0; i < n; ++i) {
        if (qq[i].size() == rr[i].size()) {
            int h = qq[i][0] - '0';
            int hr = hi[rr[i][0]];
            hi[rr[i][0]] = min(h, hr);
        }
    }

    int nextToSolve = 1;
    for(;;) {
        bool progress = true;
        while (progress) {
            progress = false;
            for (auto &kv : hi) {
                if (kv.second == nextToSolve) {
                    digits[nextToSolve] = kv.first;
                    nextToSolve ++;
                    progress = true;
                }
            }
        }
        if (nextToSolve == 10)
            break;

        for (int i = 0; i < n; ++i) {
            if (qq[i].size() == rr[i].size()) {
                for (int d = 0; d < rr[i].size(); d++) {
                    int h = qq[i][d] - '0';
                    if (digits[h] != rr[i][d]) {
                        int hr = hi[rr[i][d]];
                        hi[rr[i][d]] = min(h, hr);
                        break;
                    }

                }
            }
        }
    }
    cout << digits;
}


int main() {
    //freopen("B.in.txt", "r", stdin);

    auto nTestCases = nextValue<int>(cin);
    for (int it = 0; it < nTestCases; ++it) {
        cout << "Case #" << (it + 1) << ": ";
        solve();
        cout << endl;
    }
    return 0;
}