#include <iostream>
#include <vector>
#include <map>
#include <tuple>
#include <bits/stdc++.h>
#include <algorithm>
using namespace std;

#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define trav(a, x) for(auto& a : x)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;


void solve();
void testU(int U);
void generate(); // randomly generate

int main()
{   
    cin.sync_with_stdio(0); cin.tie(0);
    cin.exceptions(cin.failbit);

    //cout << RAND_MAX << endl;

    solve();

    return 0;
}

void solve()
{
    int num_tests;
    cin >> num_tests;
    
    for(int test_case = 1; test_case <= num_tests; test_case++){
        int U;
        cin >> U;
        ll freq[26];
        bool iszero[26];
        ll l_freq[26];
        for(int i = 0; i < 26; i++) freq[i] = 0;
        for(int i = 0; i < 26; i++) l_freq[i] = 0;
        for(int i = 0; i < 26; i++) iszero[i] = true;

        ll Mi;
        string Ri;
        for(int i = 0; i < 10000; i++){
            cin >> Mi >> Ri;
            // Process Ri
            for(char c: Ri){
                freq[c - 'A']++;
            }
            iszero[Ri[0]-'A'] = false;
            l_freq[Ri[0]-'A']++;
        }

        char res[10];
        if(U == 2){
            vector<pair<ll, char> > stats;
            for(int i = 0; i < 26; i++){
                if(freq[i] > 0){
                    stats.push_back({freq[i], 'A'+i});
                }
            }
            sort(stats.begin(), stats.end());

            res[0] = stats[0].second;
            for(int i = 9; i >= 1; i--){
                res[i] = stats[10-i].second;
            }
        }else{
            // U == 16
            vector<pair<ll, char> > stats;
            for(int i = 0; i < 26; i++){
                if(freq[i] > 0 && iszero[i]){
                    res[0] = 'A'+i;
                }
            }
            for(int i = 0; i < 26; i++){
                if(l_freq[i] > 0 && !iszero[i]){
                    stats.push_back({l_freq[i], 'A'+i});
                }
            }
            sort(stats.begin(), stats.end());
            for(int i = 9; i >= 1; i--){
                res[i] = stats[9-i].second;
            }
            //res[0] = stats.back().second;
        }

        cout << "Case #" << test_case << ": ";
        for(int i = 0; i < 10; i++){
            cout << res[i];
        }
        cout << endl;
    }
}

void testU(int U)
{
    ll uper = 1;
    for(int i = 0; i < U; i++) uper *= 10;
    ll t_freq[10];
    ll freq[10];
    for(int i = 0; i < 10; i++) t_freq[i] = freq[i] = 0;

    for(int n = 1; n < uper; n++){
        // Append to freq
        string ns = to_string(n);
        for(char c : ns) freq[c - '0']++;
        // Add freq to t_freq
        for(int i = 0; i < 10; i++) t_freq[i] += freq[i];
    }

    for(int i = 0; i < 10; i++){
        cout << i << ": " << t_freq[i] << endl;
    }
}

void generate()
{
    ll uper = 1;
    for(int i = 0; i < 16; i++) uper *= 10;

}
