#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <queue>
#include <climits>
#include <functional>
#include <utility>
#include <numeric>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <map>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> ii;
typedef vector<ii> vii;
typedef vector<ll> vll;
typedef map<int, int> mii;
typedef pair<ll, ll> ll_ll;

#define INF 1000000000

int u;
string s;

set<char> others(int limit, vector<char> const& sol) {
	set<char> s;
	for (int i = 1; i < limit; ++i) {
		s.insert(sol[i]);
	}
	return s;
}

void find_digit(int digit, map<int, vector<string>> const& db, vector<char> & sol, vector<bool> & found) {
	set<char> cjt = others(digit, sol);
	vector<string> v = db.at(digit);
	for (int i = 0; i < v.size(); ++i) {
		string s = v[i];
		if (cjt.count(s.at(0)) == 0) {
			sol[digit] = s.at(0);
			found[digit] = true;
			break;
		}
	}
}

// u == 2
void resolve2() {
	cin >> u;
	map<int, vector<string>> db;
	int num;
	string s;
	for (int i = 0; i < 10000; ++i) {
		cin >> num >> s;
		db[num].push_back(s);
	}

	vector<bool> found(10,false);
	vector<char> sol(10);
	// digit 1:
	sol[1] = db[1][0].at(0);
	found[1] = true;

	find_digit(2, db, sol, found);
	find_digit(3, db, sol, found);
	find_digit(4, db, sol, found);
	find_digit(5, db, sol, found);
	find_digit(6, db, sol, found);
	find_digit(7, db, sol, found);
	find_digit(8, db, sol, found);
	find_digit(9, db, sol, found);

	// all digits from 1 to 9
	set<char> cjt = others(10, sol);
	for (int i = 10; i <= 99 && !found[0]; ++i) {
		if(db.count(i)){
			for (auto s : db[i]) {
				for (char c : s) {
					if (cjt.count(c) == 0) {
						sol[0] = c;
						found[0] = true;
						break;
					}
				}
				if (found[0]) break;
			}
		}
	}
	for (int i = 0; i < 10; ++i) {
		cout << sol[i];
	}
	cout << '\n';
}

int main() {

	//ifstream in("in.txt"); auto cinbuf = std::cin.rdbuf(in.rdbuf());
	//ofstream out("out.txt"); auto coutbuf = std::cout.rdbuf(out.rdbuf());
	int cases;
	cin >> cases;
	for (int i = 1; i <= cases; ++i) {
		cout << "Case #" << i << ": ";
		resolve2();
	}
	return 0;
}