#include <string>
#include <vector>
#include <iostream>
#include <algorithm>
#include <map>
#include <cassert>

using namespace std;

void solveSubproblem(int testCaseIndex)
{
	int U;
	cin >> U;
	map<char, int> frequencies;

	for (int i=0; i<10000; i++)
	{
		long long X;
		string S;
		cin >> X >>  S;
		for (char c : S)
			frequencies[c]+=0;
		if (S.size() > 1)
			frequencies[S.front()]+=1;
	}

	vector<std::pair<int, char>> V;
	for (auto x : frequencies)
	{
		V.push_back({x.second, x.first});
	}
	sort(V.rbegin(), V.rend());

	string result;
	result += V.back().second;
	for (auto x : V)
	{
		result += x.second;
	}
	result.pop_back();

	cout << "Case #"<< testCaseIndex << ": " << result << "\n";
}

int main()
{
	int tests;
	cin >> tests;
	for (int t = 1; t<=tests; t++)
	{
		solveSubproblem(t);
	}
}
