#include <bits/stdc++.h>

#define INF 1000000007

using namespace std;

// void visualize(unordered_map<char, int> &ci)
// {
//     vector<pair<char, int>> cis;

//     for (auto const &cip : ci)
//     {
//         cis.push_back(cip);
//     }

//     sort(cis.begin(), cis.end(), [](const pair<char, int> &e, const pair<char, int> &v) {
//         return e.second > v.second;
//     });

//     for (auto const &cip : cis)
//     {
//         printf("%d %c\n", cip.second, cip.first);
//     }
// }

bool good(string &seq, vector<pair<long long, string>> &num_strings)
{
    int n = seq.length();

    for (int i = 0; i < n; i++)
    {
        int num = i + 1;

        for (auto const &p : num_strings)
        {
            string num_string = to_string(p.first);
            if (num_string.length() != p.second.length())
                continue;
            if (p.second[0] == seq[i] && num > num_string[0] - '0')
                return false;
        }
    }

    return true;
}

void answer(vector<unordered_map<char, int>> &freq, unordered_set<char> &non_zero, unordered_set<char> &all, vector<pair<long long, string>> &num_strings)
{
    assert(all.size() == 10);
    assert(non_zero.size() == 9);

    for (auto const &aa : all)
    {
        if (non_zero.count(aa) == 0)
        {
            printf("%c", aa);
            break;
        }
    }

    unordered_map<string, int> seq_count;

    for (auto const &ci : freq)
    {
        vector<pair<char, int>> cis;

        for (auto const &cip : ci)
        {
            cis.push_back(cip);
        }

        sort(cis.begin(), cis.end(), [](const pair<char, int> &e, const pair<char, int> &v) {
            return e.second > v.second;
        });

        int n_cis = cis.size();
        if (n_cis != 9)
        {
            continue;
        }

        string seq = "";
        for (int i = 0; i < n_cis; i++)
        {
            seq += cis[i].first;
        }

        if (!good(seq, num_strings))
        {
            continue;
        }
        seq_count[seq]++;
    }

    vector<pair<string, int>> seq_count_v;

    for (auto const &scp : seq_count)
    {
        seq_count_v.push_back(scp);
    }

    sort(seq_count_v.begin(), seq_count_v.end(), [](const pair<string, int> &e, const pair<string, int> &v) {
        return e.second > v.second;
    });

    int right = 1;
    for (; right < int(seq_count_v.size()); right++)
    {
        if (seq_count_v[right].second < seq_count_v[0].second)
            break;
    }

    std::random_device device;
    std::mt19937 generator(device());
    std::uniform_int_distribution<int> distribution(0, right - 1);

    int target_index = distribution(generator);

    cout << seq_count_v[target_index].first << endl;
}

int main()
{
    int t, q;
    string s;
    cin >> t;
    for (int tt = 1; tt <= t; tt++)
    {
        cout << "Case #" << tt << ": ";
        cin >> q;
        unordered_set<char> non_zero, all;
        vector<unordered_map<char, int>> freq(q);
        vector<pair<long long, string>> num_strings;
        for (int i = 0; i < 10000; i++)
        {
            long long temp;
            cin >> temp >> s;
            if (temp != -1)
            {
                num_strings.push_back(make_pair(temp, s));
            }

            int n = s.length();
            for (auto const &ss : s)
            {
                all.insert(ss);
            }
            char target = s[0];
            non_zero.insert(target);

            freq[n - 1][target]++;
        }

        // cout << "all char: ";
        // for (auto const &ch : all)
        // {
        //     cout << ch;
        // }

        // cout << "\nnon-zero char: ";
        // for (auto const &ch : non_zero)
        // {
        //     cout << ch;
        // }

        // cout << endl;

        // for (int index = 0; index < q; index++)
        // {
        //     printf("index %d:\n", index);
        //     visualize(freq[index]);
        // }

        answer(freq, non_zero, all, num_strings);
    }
    return 0;
}