#include <iostream>
#include <vector>
#include <map>
#include <bitset>
#include <algorithm>
#include <string>
#include <queue>
#include <stack>
#include <cmath>
#include <set>
#include <list>
#include <sstream>

#define ll long long
#define ld long double
#define ull unsigned long long
using namespace std;

const ll mod = 1000000007;
const ll inf = 9223372036854775803;

const ld eps = 1e-9;
const ld pi = acosl(-1.0);

ll dist(ll x1, ll y1, ll x2, ll y2) {
    return abs(x1-x2) + abs(y1-y2);
}

//ll decode(const vector<int>& mask, const string& s) {
//    ll ans = 0;
//    for (int i = 0; i < s.length(); i++) {
//        ans = ans*10 + mask[s[i]];
//    }
//
//    return ans;
//}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    // freopen("/Users/kronos/Developer/algo/clion/x.txt", "r", stdin);
    int t;
    cin >> t;
    for (int _case = 1; _case <= t; _case++) {
        ll u, m;
        cin >> u;
        vector<vector<pair<ll,string>>> A(17);
        vector<int> mask(256, -1);
        vector<bool> candidates(256, false);
        for (int i = 0; i < 10000; i++) { // 10000
            string s;
            cin >> m >> s;
            A[s.length()].push_back({m, s});
            for (int k = 0; k < s.length(); k++) {
                candidates[s[k]] = true;
            }
        }
        // 0123456789
        // TPFOXLUSHB
        string need;
        map<char,int> mapp;
        set<char> solved;
        vector<char> ans(10, '-');
        for(int i = 0; i < 256; i++) {
            if (candidates[i]) {
                need += char(i);
                mapp[need.back()] = need.length() - 1;
            }
        }

        // i - letters, j - numbers;
        vector<vector<bool>> table(10, vector<bool>(10, true));

        bool good = false;
        string suffix = "";
    //    while (!good) {
            for (int i = 1; (i < 17) && !good; i++) {
                sort(A[i].begin(), A[i].end());
                for (int j = 0; j < A[i].size(); j++) {
                    ll m = A[i][j].first;
                    int len = 1;
                    while (m > 9) {
                        m /= 10;
                        len++;
                    }
                    char c = A[i][j].second.front();
                    int idx = mapp[c];
                    table[idx][0] = false;
                    if (len != A[i][j].second.length()) {
                        continue;
                    }
                    if (solved.find(c) != solved.end()) {
                        continue;
                    }

                    for (int k = m + 1; k < 10; k++) {
                        table[idx][k] = false;
                    }

                    good = true;
                    for (int k = 0; k < 10; k++) {
                        int cnt = 0;
                        int lidx = -1;

                        if (solved.find(need[k]) != solved.end()) {
                            continue;
                        }

                        for (int kk = 0; (kk < 10) && (cnt < 2); kk++) {
                            if (table[k][kk]) {
                                cnt++;
                                lidx = kk;
                            }
                        }

                        if (cnt < 2 && lidx > -1) {
                            solved.insert(need[k]);
                            ans[lidx] = need[k];
                            for (int kk = 0; kk < 10; kk++) {
                                table[kk][lidx] = kk == k;
                            }
                        } else {
                            good = false;
                        }
                    }
                    if (good) {
                        break;
                    }
                }
            }
            if (ans[0] == '-') {
                for (int i = 0; i < 10; i++) {
                    if (table[i][0]) {
                        ans[0] = need[i];
                    }
                }
            }
        // }

        cout << "Case #" << _case << ": ";
        for (int i = 0; i < 10; i++) {
            cout << ans[i];
        }
        cout << "\n";
    }
    return 0;
}