#include<iostream>
#include<map>
#include<string>
#include<vector>
using namespace std;
string res = "##########";
int positions[10][16];
double eps = 0.001;
map<char, int> letters;
char intToLetter[10];
bool values[10][10];

double abs(double x){
	return x>0 ? x : -x;
}

void check(vector<int> digits){
	double avg = 0;
	long long mult = 1;
	for (int i = 0; i < 16; i++){
		long long sum = 0;
		for (int j = 0; j < 10; j++){
			sum += j * positions[digits[j]][i];
		}
		avg += (sum * mult)/10000;
		mult *= 10;
	}

	if (abs(avg - 0.5 * (mult + 1)) < eps) {
		for (int j = 0; j < 10; j++){
			res[j] = intToLetter[digits[j]]; 
		}
	}
}

void genAll(vector<int> s, vector<bool> used){
	if (s.size() == 10){
		check(s);
		return;
	}

	for (int i = 0; i < 10; i++){
		if (!used[i]){
			used[i] = true;
			s.push_back(i);
			genAll(s, used);
			s.pop_back();
			used[i] = false;
		}
	}
	return;
}

string solveCase(){

	for (int i = 0; i < 10; i++){
		for(int j = 0; j < 10; j++){
			values[i][j] = false;
		}
	}
	letters.clear();

	int u, k = 0;
	cin >> u;
	
	long long q;
	string r;
	bool noQ = false;
	for (int i = 0; i < 10000; i++){
		cin >> q >> r;
		if (q < 0){
			noQ = true;
		}
		
		for (int j = 0; j < r.size(); j++){
			if (letters.find(r[j]) == letters.end()){
				letters[r[j]] = k;
				intToLetter[k] = r[j];
				k++;
			}
		}

		values[letters[r[0]]][0] = true;
		if (!noQ){
			long long m2 = q, l = 1;
			while (m2 / 10 != 0){
				m2 = m2 / 10;
				l++;
			}

			if (l == r.size()){
				for (int j = m2 + 1; j <= 9; j++){
					values[letters[r[0]]][j] = true;
				}
			}
		} else {
			for (int i = 0; i < r.size(); i++){
				positions[letters[r[i]]][r.size() - i]++;
			}
		}
	}

	if (!noQ) {
		string result = "##########";

		for (int k = 0; k < 100; k++){
			for (int i = 0; i < 10; i++){
				int nz = 0, pz = 0;
				for (int j = 0; j < 10; j++){
					if (!values[j][i]){
						nz++;
						pz = j;
					}
				}

				if (nz == 1){
					for (int j = 0; j < 10; j++){
						values[pz][j] = true;
					}
					result[i] = intToLetter[pz];
					break;
				}
			}
		}
		return result;
	}

	int zeroLetter;
	for (int i = 0; i < 10; i++){
		if (!values[i][0]){
			zeroLetter = i;
		}
	}

	vector<int> s;
	s.push_back(zeroLetter);
	vector<bool> used(10, false);
	used[zeroLetter] = true;
	genAll(s, used);
	return res;
}


int main(){
	//freopen("input.txt","r", stdin);
	//freopen("output.txt", "w", stdout);
	int t;
	cin >> t;
	for (int q = 1; q <= t; q++){
		string res = solveCase();
		cout << "Case #" << q << ": " << res;
		if (q != t) cout << "\n";
	}
}