#include <iostream> 
#include <string>
#include <map>
#include <vector>
#include <set>
using namespace std;

set<int> intersection(set<int> a, set<int> b) {
	set<int> ans;
	if(a.size() == 0)
		return b;
	for(auto i : a) {
		if (b.find(i) != b.end())
			ans.insert(i);
	}
	return ans;
}

string valid(vector<set<char>>& m, int index, set<char>& visited, string& ans) {
	if(index == 10)
		return ans;
	auto choices = m[index];
	for(auto choice : choices) {
		if (visited.find(choice) == visited.end()) {
			visited.insert(choice);
			ans[index] = choice; 
			string temp = valid(m, index+1, visited, ans);
			visited.erase(choice);
			if(temp != "0")
				return temp;
		}
	}
	return "0";
}


int main() {
	int t;
	cin >> t;
	set<int> all_set = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9};
	set<int> one_set = {1, 2, 3, 4, 5, 6, 7, 8, 9};
	for(int idx=1; idx<=t; idx++) {
		int u;
		cin >> u;
		int query = 1e4;
		// int query = 2;
		
		map<char, set<int> > m;

		while(query--) {
			string num, r;
			cin >> num >> r;
			for(int i=1; i<r.size(); i++)
				m[r[i]] = intersection(m[r[i]], all_set);

			
			if(num[0] == '-' || r.size() < num.size()) {
				m[r[0]] = intersection(m[r[0]], one_set);
			}
			else if (r.size() == num.size()) {
				set<int> temp;
				int cur = num[0]-'0';
				for(int i=1; i<=cur; i++)
					temp.insert(i);
				m[r[0]] = intersection(m[r[0]], temp);
				temp.clear();
			}
			else {}
		}
		vector<set<char> > rmap(10);
		for(auto it = m.begin(); it!=m.end(); it++) {
			if( (it->second).size() == 0 )
				it->second = all_set;
			for(auto val : it->second) {
				rmap[val].insert(it->first);
			}
		}
		string ans(10, '-');
		set<char> visited;
		ans = valid(rmap, 0, visited, ans);		
		cout << "Case #" << idx << ": " << ans << endl;
	}
}