// By Stefan Radu

#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cassert>
#include <vector>
#include <string>
#include <cctype>
#include <queue>
#include <deque>
#include <cmath>
#include <stack>
#include <map>
#include <set>

using namespace std;

#define sz(x) (int)(x).size()

typedef pair < int, int > pii;
typedef long long ll;
typedef long double ld;
typedef unsigned int ui;
typedef unsigned long long ull;

int main() {

#ifdef STEF
  freopen("input", "r", stdin);
  freopen("output", "w", stdout);
#endif

  ios::sync_with_stdio(false);
  cin.tie(0);cout.tie(0);

  vector < vector < int > > refference;

  int ttt = 1;
  srand(time(0));
  while (ttt --) {

    ll u = pow(10, 16) - 1;

    vector < int > frecv(10);
    for (int i = 0; i < 1e8; ++ i) {

      ll a = rand();
      ll b = rand();

      ll m = (a * b) % u + 1;

      a = rand();
      b = rand();

      ll k = (a * b) % m + 1;

      while (k) {
        ++ frecv[k % 10];
        k /= 10;
      }
    }

    vector < pair < int, int > > aux;
    for (int i = 0; i < 10; ++ i) {
      aux.emplace_back(frecv[i], i);
    }

    sort(aux.begin(), aux.end());

    vector < int > au;
    for (auto &x: aux) {
      au.push_back(x.second);
    }

    refference.push_back(au);
  }

  int tt; cin >> tt;
  for (int t = 1; t <= tt; ++ t) {

    cout << "Case #" << t << ": ";

    int u;
    cin >> u;

    map < char, int > frecv;

    vector < pair < ll, string > > v(1e4);

    for (int i = 0; i < 1e4; ++ i) {
      ll q; cin >> q;
      string s; cin >> s;
      v[i] = {q, s};
      for (const char &c : s) ++ frecv[c];
    }

    vector < pair < int, char > > aux;
    for (auto &x : frecv) {
      aux.emplace_back(x.second, x.first);
    }

    sort(aux.begin(), aux.end());
    
    for (const auto &ref : refference) {

      string ans(10, '0');
      map < char, int > coresp;
      for (int i = 0; i < 10; ++ i) {
        ans[ref[i]] = aux[i].second;
        coresp[aux[i].second] = ref[i];
      }

      cout << ans << '\n';
    }
  }
}
