#include <iostream>
#include <vector>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <functional>
#include <cstring>

using namespace std;
const int numQueries = 10000;


struct request
{
    long long q;
    string r;

    request(long long _q, string _r) : q(_q), r(_r) {}
};

struct requestCmp
{
    inline bool operator() (const request& a, const request& b)
    {

        if (a.r.length() != b.r.length())
        {
            return a.r.length() < b.r.length();
        }

        if (a.q != b.q)
        {
            return a.q < b.q;
        }

        return a.r < b.r;
    }
};

vector<request> requests;
bool result;
string finalRes;

long long getNum(char *mapping, string num)
{
    int m = 1;
    long long fNum = 0;
    for (int i = 0; i < num.length(); i++)
    {
        fNum = fNum + m * mapping[num[i] - '0'];
        m = m * 10;
    }
    return fNum;
}

bool isValid(char *mapping)
{
    for (int i = 0; i < requests.size(); i++)
    {
        long long mNum = getNum(mapping, requests[i].r);
        if (mNum > requests[i].q)
        {
            return false;
        }
    }
    return true;
}

void rec(string current)
{
    if (result)
        return;
    if (current.length() == 10)
    {
        char mapping[100] = {0};
        for (int i = 0; i < current.length(); i++)
        {
            mapping[current[i] - '0'] = i;
        }
        if (isValid(mapping))
        {
            result = true;
            finalRes = current;
        }
    }
    else
    {

    }
}

void solve()
{
    int u;
    cin >> u;
    requests.clear();
    vector<char> dChar;
    char secret[11] = {0};
    bool seen[100] = {0};
    result = false;

    for (int i = 0; i < numQueries; i++)
    {
        long long q;
        string r;
        cin >> q >> r;
        requests.push_back(request(q, r));
        for (int j = 0; j < r.length(); j++)
        {
            if (!seen[r[j] - '0'])
            {
                seen[r[j] - '0'] = true;
                dChar.push_back(r[j]);
            }
        }
        if (q == 1)
        {
            secret[1] = r[0];
        }
    }
    memset(seen, 0, sizeof(seen));
    sort(requests.begin(), requests.end(), requestCmp());
    int lb = 1;
    for (int i = 0; i < requests.size(); i++)
    {
        long long q = requests[i].q;
        string r = requests[i].r;
        if (!seen[r[0]-'0'])
        {
            secret[lb] = r[0];
            seen[r[0]-'0'] = true;
            lb ++;
        }
        // cout << q << " " << r << "\n";
    }
    // find zero
    if (lb == 10)
    {

    finalRes = "";
    for (int i = 0; i < dChar.size(); i++){
        bool isInside = false;
        for (int j = 1; j < 10; j++) {
            if (secret[j] == dChar[i])
            {
                isInside = true;
                break;
            }
        }
        if (!isInside)
        {
            finalRes += dChar[i];
        }
    }

    for (int i = 1; i < lb; i++)
    {
        finalRes += secret[i];
    }
    // finalRes += '\0';
    cout << finalRes << "\n";
    return;
    }

}

int main()
{
    int t;
    cin >> t;
    for (int p = 1; p <= t; p++)
    {

        int x, y;
        string s;
        cout << "Case #" << p << ": ";
        solve();
    }
    return 0;
}
