#include <fstream>
#include <iostream>
#include <vector>
using namespace std;

int T, U;
bool D[10][10];
char C[10];
int filled;
int count[10];

void populate(string s) {
  if (filled == 10) {
    return;
  }
  for (int i = 0; i < s.size(); i++) {
    bool present = false;
    for (int j = 0; j < 10; j++) {
      if (C[j] == s[i]) {
        present = true;
        break;
      }
    }
    if (!present) {
      C[filled] = s[i];
      filled++;
    }
  }
}

vector<int> getDigits(long long int m) {
  vector<int> digits;
  while (m > 0) {
    int r = m % 10;
    m = m / 10;
    digits.push_back(r);
  }
  return digits;
}

int remove(int ind, int val);

void removeFromOthers(int ind) {
  if (count[ind] != 1) {
    cout << "something's wrong" << endl;
  } else {
    int val;
    for (int i = 0; i < 10; i++) {
      if (D[ind][i]) {
        val = i;
        break;
      }
    }
    // cout << "removeFromOthers : " << ind << " " << val << endl;
    remove(ind, val);
  }
}

int remove(int ind, int val) {
  //   cout << "remove : " << count[1] << endl;
  for (int i = 0; i < 10; i++) {
    if (i != ind) {
      //   cout << i << " " << C[i] << endl;
      if (D[i][val]) {
        D[i][val] = false;
        count[i]--;
        if (count[i] == 1) {
          removeFromOthers(i);
        }
      }
    }
  }

  //   cout << "remove : " << count[1] << endl;
}

bool update(char c, int x, bool removeZero) {
  int ind;
  for (int i = 0; i < 10; i++) {
    if (C[i] == c) {
      ind = i;
      break;
    }
  }

  //   cout << "update : " << c << " " << ind << " " << count[ind] << endl;

  for (int i = 0; i < 10; i++) {
    if (i > x) {
      if (D[ind][i]) {
        D[ind][i] = false;
        count[ind]--;
      }
    }
  }

  if (removeZero) {
    if (D[ind][0]) {
      D[ind][0] = false;
      count[ind]--;
    }
  }

  if (count[ind] == 1) {
    removeFromOthers(ind);
    int val;
    for (int i = 0; i < 10; i++) {
      if (D[ind][i]) {
        val = i;
        break;
      }
    }
    if (val == x) {
      return true;
    }
  }

  return false;
}

bool check() {
  bool gotString = true;
  for (int i = 0; i < 10; i++) {
    // cout << "check : " << count[i] << " s " << C[i] << endl;
    if (count[i] != 1 || C[i] == ' ') {
      gotString = false;
      break;
    }
  }

  return gotString;
}

string getString() {
  string result = "          ";
  for (int i = 0; i < 10; i++) {
    // cout << "result : " << C[i] << " " << count[i] << " ";
    for (int j = 0; j < 10; j++) {
      if (D[i][j]) {
        // cout << j << endl;
        result[j] = C[i];
        break;
      }
    }
  }
  return result;
}

// #define cin file

int main() {
  ifstream file("input.txt");
  cin >> T;
  //   cout << T << endl;
  for (int t = 1; t <= T; t++) {
    cin >> U;
    // cout << U << endl;
    filled = 0;
    for (int i = 0; i < 10; i++) {
      C[i] = ' ';
      count[i] = 10;
      for (int j = 0; j < 10; j++) {
        D[i][j] = true;
      }
    }
    bool gotString = false;
    for (int i = 0; i < 10000; i++) {
      long long int m;
      cin >> m;
      string s;
      cin >> s;

      //   cout << m << " " << s << endl;
      if (!gotString) {
        populate(s);
        vector<int> digits = getDigits(m);
        if (digits.size() == 1) {
          update(s[0], m, true);
        } else if (digits.size() == s.size()) {
          bool b = true;
          int l = 0;
          while (b) {
            b = update(s[l], digits[digits.size() - l - 1], false);
            l++;
          }
        }

        gotString = check();
        // if (gotString) {
        //   cout << "got string" << endl;
        //   for (int k = 0; k < 10; k++) {
        //     cout << C[k];
        //   }
        //   cout << endl;
        // }
      }
    }

    string d = getString();
    cout << "Case #" << t << ": " << d << endl;
  }
}