#include <cstdio>
 #include <vector>
 #include <algorithm>
 using namespace std;
 
 struct dsa
 {
 	int first, last, sum;
 	
 	dsa() {}
 	dsa(int first, int last, int sum) : first(first), last(last), sum(sum) {}
 };
 
 int C, D;
 vector<dsa> S;
 
 bool interf(dsa A, dsa B)
 {
 	return((long double) A.last + D - 1 + ((long double)(A.sum - 1) * D) / 2.0 >=
 		(long double) B.first - ((long double)(B.sum - 1) * D) / 2.0);
 }
 
 dsa merge(dsa A, dsa B)
 {
 	return dsa(A.first, B.last, A.sum + B.sum);
 }
 
 void fix()
 {
 	if(S.size() <= 1) return;
 	if(interf(S[S.size() - 2], S[S.size() - 1]))
 	{
 		dsa tmp = merge(S[S.size() - 2], S[S.size() - 1]);
 		S.pop_back();
 		S.pop_back();
 		S.push_back(tmp);
 		fix();
 	}
 }
 
 int main()
 {
 	int T; scanf("%i", &T);
 	
 	for(int t = 1; t <= T; ++t)
 	{
 		scanf("%i %i", &C, &D);
 		
 		for(int i = 0; i < C; ++i)
 		{
 			int P, V;
 			scanf("%i %i", &P, &V);
 			S.push_back(dsa(P, P, V));
 			fix();
 		}
 		
 		long double maks = 0.0;
 		for(int i = 0; i < S.size(); ++i)
 		{
 			dsa p = S[i];
 			maks = max(maks, ((long double)(p.sum - 1) * D - (p.last - p.first)) / 2.0);
 		}
 		printf("Case #%i: %1lf\n", t, (double) maks);
 		S.clear();
 	}
 	return 0;
 }
