#include <algorithm>
 #include <fstream>
 #include <iostream>
 #include <vector>
 
 double CalculateTime(std::vector < std::pair < int, int > > & start, int distance);
 bool Sort (std:: pair < int, int > a, std::pair < int, int > b)
 {
 	if (a.first < b.first)
 		return true;
 	return false;
 }
 
 int main(void)
 {
 	std::ifstream       input;
 	int                 candies   = 0;
 	int                 candy     = 0;
 	int                 distance  = 0;
 	int                 points    = 0;
 	int                 pp        = 0;
 	int                 testCase  = 0;
 	int                 testCases = 0;
 	int                 value     = 0;
 	std::ofstream       output;
 	std::pair < int, int > pair;
 	std::vector < std::pair < int, int > > start;
 
 	//----------------------------------------------------------------------------------------------
 	//  Open the input file.
 	//----------------------------------------------------------------------------------------------
 	input.open("B-small.in");
 	if (false == input.is_open())
 	{
 		std::cout << "Unable to open input file!" << std::endl;
 		return 1;
 	}
 
 	//----------------------------------------------------------------------------------------------
 	//  Open the output file.
 	//----------------------------------------------------------------------------------------------
 	output.open("B-small.out");
 	if (false == output.is_open())
 	{
 		std::cout << "Unable to open output file!" << std::endl;
 		input.close();
 		return 2;
 	}
 
 	//----------------------------------------------------------------------------------------------
 	//  Load the input file.
 	//----------------------------------------------------------------------------------------------
 	input >> testCases;
 
 	//----------------------------------------------------------------------------------------------
 	//  Read all the test cases.
 	//----------------------------------------------------------------------------------------------
 	for (testCase = 1; testCase <= testCases; testCase++)
 	{
 		//------------------------------------------------------------------------------------------
 		//  Read all the candies of the test case.
 		//------------------------------------------------------------------------------------------
 		input >> points;
 		input >> distance;
 
 		start.erase(start.begin(), start.end());
 
 		for (pp = 0; pp < points; pp++)
 		{
 			input >> pair.first >> pair.second;
 			start.push_back(pair);
 		}
 		sort(start.begin(), start.end(), Sort);
 
 		output.precision(9);
 		output << "Case #" << testCase << ": " << CalculateTime(start, distance) << std::endl;
 	}
 
 	input.close();
 	output.close();
 
 	return 0;
 }
 
 double CalculateTime(std::vector < std::pair < int, int > > & start, int distance)
 {
 	double maxTime = 0.0;
 	double time    = 0.0;
 	int    dd      = 0;
 	int    dubdis  = distance * 2;
 	int    vendors = 0;
 	int    vv      = 0;
 	size_t jj      = 0;
 	size_t ii      = 0;
 	std::vector < std::pair < int, int > >::iterator it;
 	std::vector < std::pair < int, int > >::iterator it2;
 
 	for (it = start.begin(); it != start.end(); it++)
 	{
 		it2 = it;
 		it2++;
 
 		if (start.end() != it2)
 			dd = it2->first - it->first;
 		else
 			dd = distance;
 
 		if (1 == it->second)
 		{
 			if (distance > dd)
 				time += (distance - dd) / 2.0;
 		}
 		else if (it->second % 2)
 		{
 			it->second--;
 			it->second /= 2;
 			it->second *= distance;
 			if (distance > dd)
 				time += (distance - dd) / 2.0;
 			time += it->second;
 		}
 		else
 		{
 			it->second /= 2;
 			it->second--;
 			it->second *= distance;
 			time += it->second;
 
 			time += distance / 2.0;
 
 			if (distance > dd)
 					time += distance - dd;
 		}
 	}
 
 	return time;
 }