#include <cstdio>
 #include <cstring>
 #include <iostream>
 using namespace std;
 
 const int   maxn = 6000 + 10;
 int         b[maxn][maxn], fa[maxn * maxn], ga[maxn * maxn], vis[maxn * maxn];
 int         c[maxn * maxn];
 int         bridge[10], fork[10];
 int         state, times, tt, n, m, timess;
 
 int gf(int x)
 {
     int ans = x;
     while (fa[ans] != ans)
         ans = fa[ans];
     while (x != ans)
     {
         int y = fa[x];
         fa[x] = ans;
         x = y;
     }
     return ans;
 }
 
 int gg(int x)
 {
     int ans = x;
     while (ga[ans] != ans)
         ans = ga[ans];
     while (x != ans)
     {
         int y = ga[x];
         ga[x] = ans;
         x = y;
     }
     return ans;
 }
 
 void uni(int x, int y)
 {
     if (gf(x) == gf(y))
         state |= 4;
     fa[gf(x)] = gf(y);
     ga[gg(x)] = gg(y);
 }
 
 int encode(int x, int y)
 {
     return (x - 1) * 2 * n + y;
 }
 
 int bo[10];
 
 void go(int j, int x, int y)
 {
     if (j == 1)
         uni(encode(x, y), encode(x - 1, y - 1));
     if (j == 2)
         uni(encode(x, y), encode(x - 1, y));
     if (j == 3)
         uni(encode(x, y), encode(x, y + 1));
     if (j == 4)
         uni(encode(x, y), encode(x + 1, y + 1));
     if (j == 5)
         uni(encode(x, y), encode(x + 1, y));
     if (j == 6)
         uni(encode(x, y), encode(x, y - 1));
 }
 
 void check(int x, int y)
 {
     
     b[x][y] = times;
     bo[1] = b[x - 1][y - 1] == times;
     bo[2] = b[x - 1][y] == times;
     bo[3] = b[x][y + 1] == times;
     bo[4] = b[x + 1][y + 1] == times;
     bo[5] = b[x + 1][y] == times;
     bo[6] = b[x][y - 1] == times;
     int i;
     for (i = 1; i <= 6; ++i)
         if (bo[i] == 0)
             break;
     if (i > 6)
         uni(encode(x, y), encode(x - 1, y - 1));
     else
     {
         for (int j = i + 1; j <= i + 6; ++j)
             if (bo[(j + 5) % 6 + 1] && !bo[(j + 4) % 6 + 1])
                 go((j + 5) % 6 + 1, x, y);
     }
     ++tt;
     for (int i = 1; i <= 6; ++i)
     {
         int j = gf(bridge[i]);
         if (vis[j] < tt)
             vis[j] = tt, c[j] = 1;
         else
             ++c[j];
         if (c[j] > 1)
             state |= 1;
     }
     ++tt;
     for (int i = 1; i <= 6; ++i)
     {
         int j = gg(fork[i]);
         if (vis[j] < tt)
             vis[j] = tt, c[j] = 1;
         else
             ++c[j];
         if (c[j] > 2)
             state |= 2;
     }
 }
 
 void init()
 {
     ++times;
     for (int i = 1; i <= 4 * n * n + 6; ++i)
         fa[i] = ga[i] = i;
     bridge[1] = encode(1, 1);
     bridge[2] = encode(1, n);
     bridge[3] = encode(n, 1);
     bridge[4] = encode(n, 2 * n - 1);
     bridge[5] = encode(2 * n - 1, n);
     bridge[6] = encode(2 * n - 1, 2 * n - 1);
     for (int i = 1; i <= 6; ++i)
         fork[i] = 4 * n * n + i;
     for (int i = 2; i < n; ++i)
         ga[encode(1, i)] = fork[1];
     for (int i = 2; i < n; ++i)
         ga[encode(i, 1)] = fork[2];
     for (int i = 2; i < n; ++i)
         ga[encode(i, i + n - 1)] = fork[3];
     for (int i = 2; i < n; ++i)
         ga[encode(i + n - 1, i)] = fork[4];
     for (int i = 2; i < n; ++i)
         ga[encode(2 * n - 1, 2 * n - i)] = fork[5];
     for (int i = 2; i < n; ++i)
         ga[encode(2 * n - i, 2 * n - 1)] = fork[6];
 }
 
 void solve()
 {
     scanf("%d%d", &n, &m);
     init();
     state = 0;
     for (int i = 1; i <= m; ++i)
     {
         int x, y;
         scanf("%d%d", &x, &y);
         check(x, y);
         if (state == 1) printf("bridge in move %d\n", i);
         if (state == 2) printf("fork in move %d\n", i);
         if (state == 3) printf("bridge-fork in move %d\n", i);
         if (state == 4) printf("ring in move %d\n", i);
         if (state == 5) printf("bridge-ring in move %d\n", i);
         if (state == 6) printf("fork-ring in move %d\n", i);
         if (state == 7) printf("bridge-fork-ring in move %d\n", i);
         if (state)
         {
             for (int j = i + 1; j <= m; ++j)
                 scanf("%d%d", &x, &y);
             return;
         }
     }
     printf("none\n");
 }
 
 int main()
 {
     freopen("b.in", "r", stdin);
     freopen("b.out", "w", stdout);
     scanf("%d", &timess);
     for (int i = 1; i <= timess; ++i)
     {
         printf("Case #%d: ", i);
         solve();
     }
     return 0;
 }
