#include<cstdio>
 #include<cstring>
 #include<iostream>
 #include<algorithm>
 #include<string>
 #include<cstdlib>
 using namespace std;
 
 #define debug(x) cout << #x << "=" << x << endl
 #define sqr(x) ((x)*(x))
 
 const int base = 100;
 const int dir[6][2] = {0,1, 1,1, 1,0, 0,-1, -1,-1, -1,0};
 int coner_x[6], coner_y[6];
 int n, m;
 
 void init() {
 	coner_x[0] = 1; 	coner_y[0] = 1;
 	coner_x[1] = n; 	coner_y[1] = 1;
 	coner_x[2] = 2*n-1;	coner_y[2] = n;
 	coner_x[3] = 2*n-1; coner_y[3] = 2*n-1;
 	coner_x[4] = n;		coner_y[4] = 2*n-1;
 	coner_x[5] = 1;		coner_y[5] = n;
 }
 int hzz(int x, int y) {
 	for (int i = 0; i < 6; i++) {
 		if (x == coner_x[i] && y == coner_y[i]) {
 			return i;
 		}
 	}
 	if (abs(x-y) == n-1) {
 		if (x > y) return 1+6;
 		else return 4+6;
 	}
 	for (int i = 0; i < 6; i++) {
 		int i2 = (i+1)%6;
 		if (abs(x-coner_x[i])+abs(x-coner_x[i2])+abs(y-coner_y[i])+abs(y-coner_y[i2]) == n-1) {
 			return i+6;
 		}
 	}	
 	return -1;
 } 
 const int MAXN = 3000*6000+100000;
 int father[MAXN], vis[MAXN];
 
 int get_father(int x) {
 	if (father[x] == x) return x;
 	father[x] = get_father(father[x]);
 	return father[x];
 }
 int is_out(int x, int y) {
 	if (abs(x-y) >=n ) return true;
 	if (x >= 2*n || x < 1 || y >= 2*n || y < 1) return true;
 	return false;
 }
 
 int get_id(int x, int y) {
 	if (is_out(x,y)) return -1;
 	return x*(2*n)+y + base;
 }
 void merge(int x, int y) {
 	x = get_father(x);
 	y = get_father(y);
 	father[x] = y;
 }
 int check_ans(int flag) {
 	int bridge = 0, fork = 0;
 	for (int p1 = 1; p1 <= 6; p1++)
 	for (int p2 = p1+1; p2 <= 6; p2++) {
 		if (get_father(p1) == get_father(p2)) bridge = 1;
 	}
 	
 	for (int p1 = 7; p1 <= 12; p1++)
 	for (int p2 = p1+1; p2 <= 12; p2++)
 	for (int p3 = p2+1; p3 <= 12; p3++) {
 		if (get_father(p1) == get_father(p2) && get_father(p2)==get_father(p3)) fork = 1;
 	}
 	return (flag | (bridge<<1) | (fork<<2));
 }
 int rr;
 string ss[8] = {"none", "ring in move", "bridge in move", "bridge-ring in move",
 				"fork in move", "fork-ring in move", "bridge-fork in move", "bridge-fork-ring in move"};
 int work() {
 	for (int i = 1; i < MAXN; i++) {
 		father[i] = i;
 		vis[i] = 0;
 	}
 	
 	int x, y;
 	int flag = 0;
 
 	cout<<"Case #"<<rr<<": ";
 	for (int i = 1; i <= m; i++) {
 		scanf("%d%d", &x, &y);
 		if (flag) continue;
 		
 		int p0 = get_id(x,y);
 		
 		for (int k1 = 0; k1 < 6; k1++)
 		for (int k2 = k1+1; k2 < 6; k2++) {
 			if (is_out(x+dir[k1][0], y+dir[k1][1]) || is_out(x+dir[k2][0], y+dir[k2][1])) continue;
 			int p1 = get_id(x+dir[k1][0], y+dir[k1][1]);
 			int p2 = get_id(x+dir[k2][0], y+dir[k2][1]);
 			if (get_father(p1) == get_father(p2)) {
 		//	cout<<"__yy"<<p1<<" "<<p2<<" "<<get_father(p1)<<" "<<get_father(p2)<<endl;
 			
 				for (int m1 = k1+1; m1 < k2; m1++)
 				for (int _m2 = k2+1; _m2 < k2+6; _m2++) {
 					if (_m2%6 == k1) break;
 					int m2 = _m2%6;
 					int p3 = get_id(x+dir[m1][0], y+dir[m1][1]);
 					int p4 = get_id(x+dir[m2][0], y+dir[m2][1]);
 					if (p3 == -1 || !vis[p3]) p3 = 0; else p3 = 1;
 					if (p4 == -1 || !vis[p4]) p4 = 0; else p4 = 1;
 					if (p3+p4 == 0) {
 						flag = 1; 
 						break;
 					}		
 				}
 			}
 		}
 		
 		vis[p0] = 1;
 		int u = hzz(x, y);
 		if (u != -1) {
 			merge(1+u, p0);
 		}
 		for (int k1 = 0; k1 < 6; k1++) {
 			if (is_out(x+dir[k1][0], y+dir[k1][1]))  continue;
 			int p1 = get_id(x+dir[k1][0], y+dir[k1][1]);
 			if (!vis[p1]) continue; 
 			merge(p0,p1);
 		}
 		flag = check_ans(flag);
 		if (flag) {
 			cout<<ss[flag]<<" "<<i<<endl;
 		}
 	}
 	if (!flag) cout<<"none"<<endl;
 	
 }
 int main()
 {
 	freopen("b0.in","r",stdin);
 	freopen("b0.out","w",stdout);
 	int caseNum;
 	scanf("%d", &caseNum);
 	
 	for (rr = 1; rr <= caseNum; rr++) {
 		scanf("%d%d", &n, &m);
 		init();
 		work();
 	}
 	
 	return 0;
 }
 	
