#include <cstring>
 #include <iostream>
 #include <string>
 #include <vector>
 #include <cmath>
 #include <map>
 #include <set>
 #include <algorithm>
 #include <cmath>
 #include <cstdio>
 
 using namespace std;
 
 
 int s, m;
 vector<int> x, y;
 
 void Load()
 {
 	cin >> s >> m;
 	x.resize(m); y.resize(m);
 	for (int i = 0; i < m; i++) {
 		cin >> x[i] >> y[i];
 	}
 }
 
 
 int rt[6003*6003];
 char crn[6003][6003];
 char edg[6003][6003];
 int mp[6003][6003];
 
 
 const int dx[6] = {-1,+1, 0, 0,+1,-1};
 const int dy[6] = { 0, 0,-1,+1,+1,-1};
 int sz;
 
 int comp;
 int fff;
 
 void Dfs(int x, int y) {
 	mp[x][y] = comp;
 	rt[x*sz+y] = fff;
 	for (int k = 0; k < 6; k++) {
 		int nx = x + dx[k];
 		int ny = y + dy[k];
 		if (nx >= 0 && nx <= 2*s && ny >= 0 && ny <= 2*s)  {
 			if (mp[nx][ny] == 0) Dfs(nx, ny);
 		}
 	}
 }
 
 int root(int x) {
 	if (rt[x] != x) rt[x] = root(rt[x]);
 	return rt[x];
 }
 
 int getx(int a) {
 	return a / sz;
 }
 
 int gety(int a) {
 	return a % sz;
 }
 
 int bits(int x) {
 	int i, ans=0;
 	int _x = x;
 	for (i = 0; i < 6; i++)
 		if (x & (1 << i) != 0) ans++;
 	x = (x & 21) + ((x >> 1) & 21);
 	x = (x & 51) + ((x >> 2) & 51);
 	x = (x & 15) + ((x >> 4) & 15);
 	//if (ans != x) cerr<<"botva " << _x << ' ' <<x << ' ' << ans << "\n" ;
 	return ans;
 }
 
 void Solve()
 {
 	sz = 2*s+1;
 	int frk = m+1, brg=m+1, rng = m+1;
 
 	int i, j;
 	for (i = 0; i <= 2*s; i++) {
 		for (j = 0; j <= 2*s; j++) {
 			mp[i][j] = 0;
 		}
 	}
 
 	for (i = 0; i < m; i++) {
 		int xx = x[i];
 		int yy = y[i];
 		int b = xx*sz+yy;
 		mp[xx][yy] = 1;
 		rt[b] = b;
 		
 		crn[xx][yy] =  edg[xx][yy] = 0;
 		int edges = 0;
 		int edgsig = 0;
 		if (xx == 1) edges++, edgsig = 1;
 		if (yy == 1) edges++, edgsig = 2;
 		if (xx-yy == s-1) edges++, edgsig = 4;
 		if (yy-xx == s-1) edges++, edgsig = 8;
 		if (xx == 2*s-1) edges++, edgsig = 16;
 		if (yy == 2*s-1) edges++, edgsig = 32;
 
 		if (edges == 1) edg[xx][yy] = edgsig;
 		if (edges == 2) crn[xx][yy] = 1;
 
 
 		for (j = 0; j < 6; j++) {
 			int nx = xx + dx[j];
 			int ny = yy + dy[j];
 			if (mp[nx][ny] == 1) {
 				int a = root(nx*sz+ny);
 				if (a != b) {
 					rt[a] = b;
 					crn[xx][yy] += crn[getx(a)][gety(a)];
 					edg[xx][yy] |= edg[getx(a)][gety(a)];	
 				}
 			}
 		}
 
 		//cerr << xx << ' ' << yy << ": " << (int)crn[xx][yy] << ' ' << (int)edg[xx][yy] << " " << edges << '\n';
 
 		if (crn[xx][yy] >= 2 && i+1 < brg)
 			brg = i+1;
 		if (bits(edg[xx][yy]) >= 3 && i+1 < frk)
 			frk = i+1;
 	}
 
 
 	comp = 1;
 	for (i = 0; i <= 2*s; i++) {
 		for (j = 0; j <= 2*s; j++) {
 			if (mp[i][j] == 0) {
 				comp++;
 				fff = i*sz+j;
 				Dfs(i, j);
 			}
 		}
 	}
 
 	comp--;
 	i = m-1;
 	while (comp > 1) {
 	    int xx = x[i];
 	    int yy = y[i];
 	    mp[xx][yy] = 0;
 	   	int b = xx*sz + yy;
 	   	rt[b] = b;
 	   	comp++;
 	   	for (j = 0; j < 6; j++) {
 	   		int nx = xx + dx[j];
 			int ny = yy + dy[j];
 			if (mp[nx][ny] != 1) {
 				int a = root(nx*sz+ny);
 				if (a != b) {
 					comp--;
 					rt[a] = b;
 				}
 			}
 	   	}
 		i--;
 	}
 	rng = i+2;
 
 	int mn = frk;
 	if (mn > brg) mn = brg;
 	if (mn > rng) mn = rng;
 	if (mn > m) cout << "none\n";
 	else {
 		bool fst = true;
 		if (brg == mn) {
 			if (fst) fst = false;
 			else cout << '-';
 			cout << "bridge";
 		}
 		if (frk == mn) {
 			if (fst) fst = false;
 			else cout << '-';
 			cout << "fork";
 		}
 		if (rng == mn) {
 			if (fst) fst = false;
 			else cout << '-';
 			cout << "ring";
 		}
 		cout << " in move " << mn << "\n";
 	}
 }
 
 int main()
 {
 	int nt, tt;
 	cin >> nt;
 	for (tt = 1; tt <= nt; tt++) {
 		cout << "Case #" << tt << ": ";
 		Load();
 		Solve(); 
 	}
 	return 0;
 }
