#include<stdio.h>
 #include<algorithm>
 #include<map>
 #include<string>
 #include<string.h>
 #include<set>
 #include <vector>
 
 using namespace std;
 #define maxn 20000
 map<pair<int,int>,int > all;
 
 int i,j,n,m;
 
 int di[6][2]={
         1,0,
         -1,0,
         0,1,
         0,-1,
         1,1,
         -1,-1
 };
         
         
 
 int findPlace(pair<int,int> a){
         if(all.find(a)==all.end()){
                 return 0;
         }
         return all[a];
 }
 
 
 
 bool corner(pair<int,int> a){
         if(a.first==a.second&&(a.first==1||a.first==m+m-1))
                 return 1;
         if(a.first>a.second){
                 swap(a.first,a.second);
         }
         if(a.first==1&&a.second==m)
                 return 1;
         if(a.first==m&&a.second==m+m-1)
                 return 1;
         return 0;
 }
 
 int side(pair<int,int> a){
         if(corner(a))
                 return 0;
         int base=1;
         if(a.first>a.second){
                 swap(a.first,a.second);
                 base=8;
         }
         if(a.first==1||a.second==m+m-1){
                 if(a.first==1){
                         return 1*base;
                 }else
                         return 2*base;
                 return 1;
         }
         if(a.second-a.first==m-1)
                 return 4*base;
         return 0;
 }
 
 bool inside(pair<int,int> a){
         if(a.first>a.second){
                 swap(a.first,a.second);
         }
         if(a.first<1)
                 return 0;
         if(a.second>m+m-1)
                 return 0;
         if(a.second-a.first>=m)
                 return 0;
         return 1;
 }
 
 int count(int a){
         int ans=0;
         while(a){
                 if(a&1)
                         ans++;
                 a/=2;
         }
         return ans;
 }
 
 struct dsPoint{
         int sum,side,corner;
         void merge(dsPoint& a){
                 sum+=a.sum;
                 side|=a.side;
                 corner+=a.corner;
         }
         void init(){
                 sum=1;
                 side=corner=0;
         }
         int check(){
                 int ans=0;
                 if(count(side)>2){
                         ans|=1;
                 }
                 if( corner>1){
                         ans|=2;
                 }
                 return ans;
         }
 }p[maxn];
 
 
 int fa[maxn];
 
 pair<int,int> que[maxn];
 
 int findfa(int a){
         if(fa[a]==a)
                 return a;
         return fa[a]=findfa(fa[a]);
 }
 
 void merge(int a,int b){
         a=findfa(a);
         b=findfa(b);
         if(a==b)
                 return;
         if(p[a].sum>p[b].sum)
                 swap(a,b);
         fa[a]=b;
         p[b].merge(p[a]);
 }
 
 
 void try_merge(int a,pair<int,int> b){
 
         if(!inside(b))
                 return ;
 
 
         int i=findPlace(b);
 
         if(i==0)
                 return;
         merge(a,i);
 }
 
 bool q[1000][1000];
 
 bool checkdfs(pair<int,int> a){
         int i;
         if(!inside(a))
                 return 0;
         if(findPlace(a))
                 return 0;
         if(side(a)||corner(a))
                 return 1;
         if(q[a.first][a.second])
                 return 0;
         q[a.first][a.second]=1;
         for(i=0;i<6;i++){
                 if(checkdfs(make_pair(a.first+di[i][0],a.second+di[i][1])))
                         return 1;
         }
         return 0;
 }
 
 int checkRing(){
         int i,j;
         memset(q,0,sizeof(q));
         for(i=1;i<=m+m-1;i++){
                 for(j=1;j<=m+m-1;j++){
                         pair<int,int> now=make_pair(i,j);
                         if(inside(now)&&!findPlace(now)){
                                 if(!q[i][j]){
                                         if((!side(now))&&(!corner(now))){
                                                 if(!checkdfs(now))
                                                         return 1;
                                         }
                                 }
                         }
                 }
         }
         return 0;
 }
 
 
 
 int main(){
 
         int ii,nn,ans=0,ansa;
         scanf("%d",&nn);
         for(ii=1;ii<=nn;ii++){
                 ans=ansa=0;
                 all.clear();
                 printf("Case #%d:",ii);
                 scanf("%d %d",&m,&n);
                 for(i=1;i<=n;i++){
                         fa[i]=i;
                         p[i].init();
                 }
                 int a,b;
                 for(i=1;i<=n;i++){
                         scanf("%d %d",&a,&b);
                         que[i]=make_pair(a,b);
                         all[que[i]]=i;
                         if(corner(que[i])){
                                 p[i].corner++;
                         }else if(side(que[i])){
                                 p[i].side=side(que[i]);
 
                         }
                         for(j=0;j<6;j++){
                                 try_merge(i,make_pair(a+di[j][0],b+di[j][1]));
                         }
                         int j=checkRing();
                         if(ans==0&&(p[findfa(i)].check()||j)){
                                 ans=i;
                                 ansa=(p[findfa(i)].check()|(j*4));
                         }
 
                 }
                 if(ans){
                         bool o=false;
                         if(ansa&2){
                                 printf(" bridge");
                                 o=true;
                         }
                         if(ansa&1){
                                 if(o)
                                         printf("-fork");
                                 else
                                 printf(" fork");
                                 o=1;
                         }
                         if(ansa&4){
                                 if(o)
                                 printf("-ring");
                                 else
                                 printf(" ring");
                         }
 
                         printf(" in move %d\n",ans);
                 }else{
                         printf(" none\n");
                 }
 
         }
         return 0;
 }
