#include <cstdio>
 #include <cstring>
 int dx[6] = {0,1,1,0,-1,-1};
 int dy[6] = {-1,0,1,1,0,-1};
 bool ring,bridge,rring,folk,stone[700][700],space[700][700],chk[500000],flag;
 int s,m,corner[500000],edge[500000],prt[500000];
 int stepx[10000],stepy[10000];
 void output()
 {
 	if(ring && bridge && folk)
 		printf("bridge-fork-ring");
 	else if(ring && bridge)
 		printf("bridge-ring");
 	else if(ring && folk)
 		printf("fork-ring");
 	else if(folk && bridge)
 		printf("bridge-fork");
 	else if(ring)
 		printf("ring");
 	else if(folk)
 		printf("fork");
 	else if(bridge)
 		printf("bridge");
 }
 int hash(int x,int y)
 {
 	return x*(2*s-1) + y;	
 }
 int cnt(int x)
 {
 	int i,re=0;
 	for(i=1;i<=6;i++)
 		if((1<<i)&x)
 			re++;
 	return re;	
 }
 int find(int x)
 {
 	if(prt[x] == -1)
 		return x;
 	prt[x] = find(prt[x]);
 	return prt[x];	
 }
 void uni(int x,int y)
 {
 	int u,v;
 	u = find(x); v = find(y);
 	prt[v] = u;
 	corner[u] |= corner[v];
 	edge[u] |= edge[v];
 	if(cnt(corner[u]) >= 2)
 		bridge = true;
 	if(cnt(edge[u]) >= 3)
 		folk = true;
 }
 void ini()
 {
 	for(int i=0;i<=2*s;i++)
 		for(int j=0;j<=2*s;j++)
 			stone[i][j] = false,space[i][j] = true;
 	for(int i=0;i<=4*s*s;i++)
 		prt[i] = -1;
 	memset(edge,0,sizeof(edge));
 	memset(corner,0,sizeof(corner));
 	corner[hash(1,1)] = 1<<1;
 	corner[hash(1,s)] = 1<<2;
 	corner[hash(s,2*s-1)] = 1<<3;
 	corner[hash(2*s-1,2*s-1)] = 1<<4;
 	corner[hash(2*s-1,s)] = 1<<5;
 	corner[hash(s,1)] = 1<<6;
 	for(int i=s+1;i<2*s-1;i++)
 	{
 		edge[hash(i,2*s-1)] = 1<<3;
 		edge[hash(2*s-1,i)] = 1<<4;
 		edge[hash(i,i-s+1)] = 1<<5;
 		edge[hash(i-s+1,i)] = 1<<2;
 		edge[hash(i-s+1,1)] = 1<<6;
 		edge[hash(1,i-s+1)] = 1<<1;	
 	}
 	ring = bridge = folk = flag = rring = false;
 }
 bool circle(int x,int y,int tx,int ty,int fromx,int fromy)
 {
 	chk[hash(x,y)] = true;
 	for(int a=0;a<6;a++)
 		if(stone[x+dx[a]][y+dy[a]] && !chk[hash(x+dx[a],y+dy[a])])
 			if(circle(x+dx[a],y+dy[a],tx,ty,x,y) || (x+dx[a] == tx && y+dy[a] == ty))
 				return true;
 	chk[hash(x,y)] = false;	
 }
 int main()
 {
 	freopen("B.in","r",stdin);
 	freopen("B.out","w",stdout);
 	int cn,T,i,x,y,a,b,min_ring;
 	scanf("%d",&T);
 	for(cn=1;cn<=T;cn++)
 	{
 		printf("Case #%d: ",cn);
 		scanf("%d%d",&s,&m);
 		ini();
 		for(i=1;i<=m;i++)
 		{
 			scanf("%d%d",&x,&y);
 			stepx[i] = x; stepy[i] = y;
 			space[x][y] = false;
 		}
 		for(x=1;x<2*s;x++)
 		for(y=1;y<2*s;y++)
 			for(a=0;a<6;a++)
 				if(space[x+dx[a]][y+dy[a]] && space[x][y])
 					if(find(hash(x+dx[a],y+dy[a])) != find(hash(x,y)))
 						uni(hash(x+dx[a],y+dy[a]),hash(x,y));
 		for(i=m;i>=0;i--)
 		{
 			rring = false;
 			for(x=1;x<2*s;x++)
 				for(y=1;y<2*s;y++)
 					if(space[x][y] && corner[find(hash(x,y))] == 0 && edge[find(hash(x,y))] == 0)
 						rring = true;
 			if(!rring ) break;
 			x = stepx[i]; y = stepy[i]; space[x][y] = true;
 			for(a=0;a<6;a++)
 				if(space[x+dx[a]][y+dy[a]] && space[x][y])
 					if(find(hash(x+dx[a],y+dy[a])) != find(hash(x,y)))
 						uni(hash(x+dx[a],y+dy[a]),hash(x,y));	
 		}
 		min_ring = i+1;
 		ini();
 		for(i=1;i<=m;i++)
 		{
 			x = stepx[i]; y = stepy[i];
 			stone[x][y] = true;
 			if(i < min_ring)
 				ring = false;
 			else
 				ring = true;
 			/*for(a=0;a<6;a++)
 				for(b=0;b<6;b++)
 				{
 					if(a == b) continue;
 					if(stone[x+dx[a]][y+dy[a]] && stone[x+dx[b]][y+dy[b]])
 					{
 						if( find(hash(x+dx[a],y+dy[a])) == find(hash(x+dx[b],y+dy[b])) )
 							if(circle(x,y,x,y,-1,-1))
 								ring = true;
 					}	
 				}*/
 			for(a=0;a<6;a++)
 				if(stone[x+dx[a]][y+dy[a]])
 					if(find(hash(x+dx[a],y+dy[a])) != find(hash(x,y)))
 						uni(hash(x+dx[a],y+dy[a]),hash(x,y));
 			if(!flag)
 			if(ring || bridge || folk)
 			{
 				output();
 				printf(" in move %d\n",i);
 				flag = true;
 				//break;
 			}
 		}	
 		if(!flag)
 			printf("none\n");
 		//for(;i<=m;i++)
 		//	scanf("%d%d",&x,&y);
 	}	
 }
