#include <iostream>
 #include <string>
 #include <map>
 #include <set>
 #include <vector>
 
 using namespace std;
 
 void doCase(int caseNum) {
     int P, Q;
 
     cin >> P >> Q;
 
     vector<int> pris;
     pris.reserve(Q);
 
     int head = 0;
     int tail = P + 1;
 
     for (int i = 0; i < Q; i++) {
         int q;
         cin >> q;
         pris.push_back(q);
     }
 
     set<int> there;
 
     int coins = 0;
     // Find the prisoner with the biggest range on either side, and release him
     while (there.size() < pris.size()) {
         vector<int>::iterator it;
         int idx = -1;
         int minrange = P+3;
         int mytop = -1, mybottom = -1;
         for (int i = 0; i < pris.size(); i++) {
             // Already released
             if (there.count(i) > 0) continue;
 
             // Find range
             int top = P+1;
             for (int j = i+1; j < pris.size(); j++) {
                 if (there.count(j) == 0) {
                     // A gap
                     top = pris[j];
                     break;
                 }
             }
             int bottom = 0;
             for (int j = i-1; j >= 0; j--) {
                 if (there.count(j) == 0) {
                     // A gap
                     bottom = pris[j];
                     break;
                 }
             }
 
             if ((top - bottom) < minrange) {
                 idx = i;
                 minrange = top - bottom;
                 mytop = top;
                 mybottom = bottom;
             }
         }
 
         if (idx == -1) {
             cerr << "Didn't find prisoner" << endl;
             exit(1);
         }
 
         // Add 'idx'
         there.insert(idx);
 
         /*
         // Count coins
         int below = 0;
         for (int i = idx - 1; i >= 0; i--) {
             if (there.count(i) > 0) {
                 below = pris[i];
                 break;
             }
         }
         int above = P+1;
         for (int i = idx + 1; i < pris.size(); i++) {
             if (there.count(i) > 0) {
                 above = pris[i];
                 break;
             }
         }
         */
 
         int newcoins = mytop - mybottom - 2;
         coins += newcoins;
 //        cout << "Adding " << pris[idx] << " for " << newcoins << " new coins" << endl;
     }
 
     cout << "Case #" << caseNum << ": " << coins << endl;
 }
 
 int main() {
     int T;
     cin >> T;
 
     for (int i = 0; i < T; i++) {
         doCase(i+1);
     }
 }
