#define _CRT_SECURE_NO_DEPRECATE
 #include <iostream>
 #include <sstream>
 #include <cstdio>
 #include <cstdlib>
 #include <cmath>
 #include <memory>
 #include <cctype>
 #include <string>
 #include <vector>
 #include <list>
 #include <queue>
 #include <deque>
 #include <stack>
 #include <map>
 #include <set>
 #include <algorithm>
 using namespace std;
 
 typedef long double Double;
 typedef vector<int> VInt;
 typedef vector< vector<int> > VVInt;
 typedef long long Int;
 typedef pair<int, int> PII;
 
 #define FOR(i, n, m) for(i = n; i < m; ++i)
 #define RFOR(i, n, m) for(i = (n) - 1; i >= (m); --i)
 #define CLEAR(x, y) memset(x, y, sizeof(x))
 #define COPY(x, y) memcpy(x, y, sizeof(x))
 #define PB push_back
 #define MP make_pair
 #define SIZE(v) ((int)((v).size()))
 #define ALL(v) (v).begin(), (v).end()
 
 //#pragma comment(linker, "/STACK:100000000")
 
 double X[3];
 double Y[3];
 double X1[3];
 double Y1[3];
 
 double det3(double A[3][3])
 {
 	return A[0][0]*A[1][1]*A[2][2] + A[0][1]*A[1][2]*A[2][0] + A[1][0]*A[2][1]*A[0][2]
 	 - A[0][2]*A[1][1]*A[2][0] - A[0][1]*A[1][0]*A[2][2] - A[2][1]*A[1][2]*A[0][0];
 }
 
 double det2(double A[2][2])
 {
 	return A[0][0]*A[1][1] - A[0][1]*A[1][0];
 }
 
 #define eps 1e-9
 
 inline bool isnull(double x)
 {
 	return fabs(x) < eps;
 }
 
 bool inside(double x, double y)
 {
 	double s = fabs((X1[1]-X1[0])*(Y1[2]-Y1[0]) - (Y1[1]-Y1[0])*(X1[2]-X1[0]));
 	double s2 = fabs((X1[0]-x)*(Y1[1]-y) - (X1[1]-x)*(Y1[0]-y))
 		+ fabs((X1[2]-x)*(Y1[1]-y) - (X1[1]-x)*(Y1[2]-y))
 		+ fabs((X1[2]-x)*(Y1[0]-y) - (X1[0]-x)*(Y1[2]-y));
 	return isnull(s-s2);
 }
 
 int main()
 {
 	freopen("A-small.in", "r", stdin);
 	freopen("A-small.out", "w", stdout);
 //	freopen("-large.in", "r", stdin);
 //	freopen("-large.out", "w", stdout);
 	int T, t;
 	scanf("%d", &T);
 	for (t = 0; t < T; ++t)
 	{
 		int i;
 		for (i = 0; i < 3; ++i)
 			scanf("%lf%lf", &X[i], &Y[i]);
 		for (i = 0; i < 3; ++i)
 			scanf("%lf%lf", &X1[i], &Y1[i]);
 		double A[3][3];
 		double B[3];
 		for (i = 0; i < 3; ++i)
 		{
 			A[i][0] = X[i];
 			A[i][1] = -Y[i];
 			A[i][2] = 1;
 			B[i] = X1[i];
 		}
 		double det = det3(A);
 		if (isnull(det))
 			throw 0;
 		double C[3][3];
 		double R[3];
 		for (i = 0; i < 3; ++i)
 		{
 			int x, y;
 			for (x = 0; x < 3; ++x)
 				for (y = 0; y < 3; ++y)
 					if (y == i)
 						C[x][y] = B[x];
 					else
 						C[x][y] = A[x][y];
 			double det1 = det3(C);
 			R[i] = det1/det;
 		}
 		double a, b, dx, dy;
 		a = R[0];
 		b = R[1];
 		dx = R[2];
 
 		for (i = 0; i < 3; ++i)
 		{
 			A[i][0] = Y[i];
 			A[i][1] = X[i];
 			A[i][2] = 1;
 			B[i] = Y1[i];
 		}
 		det = det3(A);
 		if (isnull(det))
 			throw 0;
 		for (i = 0; i < 3; ++i)
 		{
 			int x, y;
 			for (x = 0; x < 3; ++x)
 				for (y = 0; y < 3; ++y)
 					if (y == i)
 						C[x][y] = B[x];
 					else
 						C[x][y] = A[x][y];
 			double det1 = det3(C);
 			R[i] = det1/det;
 		}
 
 		if (!isnull(a-R[0]) || !isnull(b-R[1]))
 			throw 0;
 		dy = R[2];
 
 		double A1[2][2];
 		A1[0][0] = a-1;
 		A1[0][1] = -b;
 		A1[1][0] = b;
 		A1[1][1] = a-1;
 		double B1[2];
 		B1[0] = -dx;
 		B1[1] = -dy;
 		det = det2(A1);
 		if (isnull(det))
 		{
 			A1[0][0] = B1[0];
 			A1[1][0] = B1[1];
 			double det1 = det2(A1);
 			if (!isnull(det1))
 			{
 				printf("Case #%d: No Solution\n", t+1);
 				fprintf(stderr, "%d\n", t+1);
 				continue;
 			}
 			if (!isnull(X[0]-X1[0]) || !isnull(Y[0]-Y1[0]))
 				throw 0;
 			printf("Case #%d: %.9lf %.9lf\n", t+1, X[0], Y[0]);
 			fprintf(stderr, "%d\n", t+1);
 			continue;
 		}
 		double C1[2][2];
 
 		for (i = 0; i < 2; ++i)
 		{
 			int x, y;
 			for (x = 0; x < 2; ++x)
 				for (y = 0; y < 2; ++y)
 					if (y == i)
 						C1[x][y] = B1[x];
 					else
 						C1[x][y] = A1[x][y];
 			double det1 = det2(C1);
 			R[i] = det1/det;
 		}
 
 		if (isnull(R[0]))
 			R[0] = 0;
 		if (isnull(R[1]))
 			R[1] = 0;
 		if (inside(R[0], R[1]))
 			printf("Case #%d: %.9lf %.9lf\n", t+1, R[0], R[1]);
 		else
 			printf("Case #%d: No Solution\n", t+1);
 		fprintf(stderr, "%d\n", t+1);
 	}
 	return 0;
 };
