//============================================================================
 // Name        : gcj-round1b-b.cpp
 // Author      : Martin Trenkmann
 // Description : Picking Up Chicks
 // Input       : *.in from std::cin
 //============================================================================
 
 #include <stdint.h>
 #include <iostream>
 #include <cstdlib>
 #include <cstring>
 #include <string>
 #include <vector>
 
 struct Chick {
 	Chick()
 	:	loc_(0), vel_(0)
 	{}
 	Chick(unsigned loc, unsigned vel)
 	:	loc_(loc), vel_(vel)
 	{}
 	unsigned loc_;
 	unsigned vel_;
 };
 
 int main(int argc, char* argv[])
 {
 	unsigned task_count(0);
 	unsigned chicken_count(0);     // N
 	unsigned chicken_to_save(0);   // K
 	unsigned barn_location(0);     // B
 	unsigned time_limit(0);        // T
 
 	unsigned locale_swap(0);
 	unsigned global_swap(0);
 	unsigned saved_chicken(0);
 
 	std::cin >> task_count;
 	for (unsigned t(0); t != task_count; ++t)
 	{
 		std::cin >> chicken_count >> chicken_to_save
 		         >> barn_location >> time_limit;
 
 		std::vector<Chick> chicks(chicken_count);
 		for (unsigned i(0); i != chicken_count; ++i)
 		{
 			std::cin >> chicks.at(i).loc_;
 		}
 		for (unsigned i(0); i != chicken_count; ++i)
 		{
 			std::cin >> chicks.at(i).vel_;
 		}
 
 		for (unsigned i(0); i != time_limit; ++i)
 		{
 			// move chicks
 			std::vector<Chick>::iterator it(chicks.begin());
 			for (; it != chicks.end();)
 			{
 				it->loc_ += it->vel_;
 				if (it->loc_ >= barn_location)
 				{
 					it = chicks.erase(it);
 					++saved_chicken;
 				}
 				else
 				{
 					++it;
 				}
 			}
 			// early termination
 			if (chicks.empty() || saved_chicken >= chicken_to_save) break;
 
 			// find catches and swap
 			do
 			{
 				locale_swap = 0;
 				for (unsigned j(0); j != chicks.size()-1; ++j)
 				{
 					if (chicks.at(j).loc_ >= chicks.at(j+1).loc_ &&
 						chicks.at(j).vel_ >  chicks.at(j+1).vel_)
 					{
 						std::swap(chicks.at(j), chicks.at(j+1));
 						++locale_swap;
 						++global_swap;
 					}
 				}
 			} while (locale_swap != 0);
 		}
 
 		std::cout << "Case #" << t+1 << ": ";
 		if (saved_chicken >= chicken_to_save)
 		{
 			std::cout << global_swap;
 		}
 		else
 		{
 			std::cout << "IMPOSSIBLE";
 		}
 		std::cout << std::endl;
 		saved_chicken = 0;
 		global_swap = 0;
 	}
 	return EXIT_SUCCESS;
 }
