#include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
 #include <math.h>
 #define static_size(p) (sizeof(p) / sizeof(*p))
 
 #if 0
 long long _atoll(const char *nptr)
 {
 	unsigned len = strlen(nptr);
 	long long num = 0, mag = 1;
 	while (--len)
 	{
 		char n = nptr[len] - '0';
 		num += n * mag;
 		mag *= 10;
 	}
 	return num;
 }
 #endif
 
 int is_tidy(size_t n)
 {
 	/* tests if digits are sorted in non-decreasing order
 	 * digits smaller than 10 are always tidy
 	 */
 /*	unsigned len = ceil(log10(n));
 	char *buf = (char *) malloc(sizeof(char) * len + 1); */
 	char buf[20];
 	sprintf(buf, "%zu", n);
 	unsigned i, tidy = 1;
 	for (i = 1; tidy && buf[i]; i++)
 		if (buf[i - 1] > buf[i])
 			tidy = !tidy;
 /*	free(buf); */
 	return tidy;
 }
 
 char *get_filebuffer(const char *path)
 {
 	FILE *fp;
 	if (!(fp = (!strcmp("-", path)) ? stdin : fopen(path, "r")))
 		return NULL;
 	fseek(fp, 0, SEEK_END);
 	size_t len = ftell(fp);
 	fseek(fp, 0, SEEK_SET);
 	char *buf = (char *) malloc(sizeof(char) * len + 1);
 	fread(buf, len, 1, fp);
 	fclose(fp);
 	return buf[len] = '\0', buf;
 }
 
 int main(int argc, char **argv)
 {
 	char *file;
 	if (!argv[1] || !(file = get_filebuffer(argv[1])))
 	{
 		printf("usage: %s [file]\n", argv[0]);
 		return 1;
 	}
 	char *tok = strtok(file, "\n ");
 	tok = strtok(NULL, "\n "); /* ignore first case */
 	size_t count = 1;
 	while (tok != NULL)
 	{
 		size_t n = atoll(tok);
 		size_t i, last = 0;
 		for (i = 1; i <= n; i++)
 		{
 			if (is_tidy(i) && i > last)
 				last = i;
 		}
 		tok = strtok(NULL, "\n ");
 		printf("Case #%zu: %zu\n", count++, last);
 	}
 	free(file);
 	return 0;
 }
