#include <iostream>  // includes cin to read from stdin and cout to write to stdout
 #include <string>
 #include <fstream>
 #include <stdint.h>
 #include <vector>
 #include <cstdlib>
 #include <cmath>
 #include <unistd.h>
 using namespace std;  // since cin and cout are both in namespace std, this saves some text
 
 
 // works, do not touch
 bool is_tidy(uint64_t num){
     if(num <= 9ULL){
         return true;
     }
     std::string num_s = std::to_string(num);
     uint8_t digit = (uint8_t)(num_s[0] - '0');
 //    printf("%s\n",num_s.c_str());
 
     for(uint8_t i = num_s.length()-1; i >= 1; i--){
         if((uint8_t)(num_s[i] - '0') < (uint8_t)(num_s[i-1] - '0')){
             return false;
         }
     }
     //printf("%llu\n",num);
     return true;
 }
 
 // works, do not touch
 uint64_t brute_solve(uint64_t in){
     uint64_t d = 1;
     for(uint64_t i = in; i > 0; i=i-d){
         if(is_tidy(i)){
             //printf("%llu\n",i);
             return i;
         }
     }
     return false;
 
 }
 
 
 uint64_t exp10(unsigned exp){
     if(exp >= 18){
         return (uint64_t)pow(10,18);
     }
     return (uint64_t)pow(10,exp);
 }
 
 // start at the bottom and move up, checking pairs for being "out of spec"
 uint64_t smart_solve(uint64_t num){
     // 14523 -> 1
     // start at the bottom and move up, checking pairs for being "out of spec"
     if(is_tidy(num)){
         return num;
     }
     if(num <= 1500){
         return brute_solve(num);
     }
     std::string num_s = std::to_string(num);
 
     uint8_t l_digit = (uint8_t)(num_s[0] - '0');
     uint8_t digit;
     uint8_t i_digit;
     uint64_t i_num;
     for(uint8_t i = 1; i < num_s.length(); i++){
         digit = (uint8_t)(num_s[i] - '0');
         i_digit = (10*l_digit) + digit;
         if(l_digit > digit){
 
                 unsigned temp = (unsigned) num_s.length();
                 uint64_t next = num - exp10(temp - i -1);
                 i_digit--;
                 i_num = ((i_digit) * exp10(temp-i-1));
 
                 //printf("num:%llu\n      next:%llu\n      current_pow:%u\n      i_digit:%i\n      i_digit:%llu\n",num,next,temp-i-1,i_digit,i_num);
                 //usleep(250);
                 return smart_solve(next);
         }
         l_digit = digit;
     }
     if(is_tidy(num)){
         return num;
     }
 }
 
 
 int main(){
     std::fstream out;
     std::fstream in;
     bool first = true;
     out.open("output", std::fstream::in | std::fstream::out | std::fstream::trunc);
     in.open("B-large.in", std::fstream::in | std::fstream::out | std::fstream::in);
     unsigned num_test_cases;
     in >> num_test_cases;
     uint64_t num;
     for(unsigned i = 1; i <= num_test_cases; i++){
         in >> num;
         out << "Case #" << i << ": ";
         printf("%llu -> %llu\n",num,smart_solve(num));
         if(num <= 10000){
             out << brute_solve(num);
         } else{
             out << smart_solve(num);
         }
         out << endl;
     }
 
 
     int k;
 
 
     return 0;
 }
