#include <stdio.h>
 
 long long int getBaseNubmer(int base);
 long long int recursiveFindTidyNumber(long long int number);
 long long int getLeftCutNumber(long long int number, int digitsToCut);
 int getTheIthNumber(long long int number, int IthNumber);
 int findNumberOfDigits(long long int number);
 long long int getBaseNubmer(int base);
 
 int main(int argc, char* argv[]) {
 
 	long long int number;
 	int testNumer = 0;
 	int i = 1;
 	FILE* input = fopen("input.txt", "r");
 	FILE* output = fopen("output.txt", "w");
 	int numberOfConversions = 0;
 	numberOfConversions = fscanf(input, "%d", &testNumer); // trow away the test number... it is not nessearry
 	numberOfConversions = fscanf(input, "%lli", &number);
 	while (numberOfConversions != EOF)
 	{
 		fprintf(output, "Case #%d: %lli\n", i, recursiveFindTidyNumber(number));
 		numberOfConversions = fscanf(input, "%lli", &number);
 		i++;
 	}
 
 	fclose(input);
 	fclose(output);
 }
 
 // lengthToEvalue is a number of digits of which to evalue the given number
 long long int recursiveFindTidyNumber(long long int number)
 {
 	int lengthToEvalue = findNumberOfDigits(number);
 	int left = 0;
 	int right = 0;
 	for (int i = 2; i <= lengthToEvalue; i++)
 	{
 		left = getTheIthNumber(number, i);
 		right = getTheIthNumber(number, i - 1);
 		if (right < left)
 		{
 			// this means that these two pairs are not "sorted"
 			number = number - getLeftCutNumber(number, lengthToEvalue - i + 1) - 1;
 		}
 	}
 	return number;
 }
 
 //from left to right
 long long int getLeftCutNumber(long long int number, int digitsToCut)
 {
 	digitsToCut--;
 	number = number % getBaseNubmer(findNumberOfDigits(number) - digitsToCut);
 	return number;
 }
 
 // from right to left
 int getTheIthNumber(long long int number, int IthNumber)
 {
 	int numberOfDigits = findNumberOfDigits(number);
 	long long int wNumber = number;
 	int i = 0;
 	for (i = 0; i < numberOfDigits - IthNumber; i++)
 	{
 		wNumber = wNumber % getBaseNubmer(numberOfDigits - i);
 	}
 
 	long long int offset = (wNumber % getBaseNubmer(numberOfDigits - i));
 	wNumber = (wNumber - offset) / getBaseNubmer(IthNumber);
 	return (int)wNumber;
 }
 
 int findNumberOfDigits(long long int number)
 {
 	long long int i = 10;
 	int size = 1;
 	while (number >= 10)
 	{
 		//			System.out.println(number);
 		number = number / i;
 		size++;
 	}
 	return size;
 }
 long long int getBaseNubmer(int base)
 {
 	long long int number = 1;
 	for (int i = 1; i < base; i++)
 	{
 		number *= 10;
 	}
 	return number;
 }
