#include <iostream>
 #include <cstring>
 #include <cstdio>
 #include <vector>
 #include <cmath>
 #include <map>
 using namespace std;
 
 typedef unsigned long long ull;
 int T, n, j;
 int ans[20];
 //ull num[20];
 vector<int> num[20];
 
 void mul(vector<int> &x, ull y)
 {
     ull k = 0;
     for (int i = 0; i < x.size(); i++)
     {
         x[i] = x[i]*y + k;
         k = x[i]/10;
         x[i] %= 10;
     }
     for (;k;k/=10)
         x.push_back(k%10);
 }
 
 void add(vector<int> &x, ull y)
 {
     for (int i = 0; i < x.size(); i++)
     {
         x[i] += y;
         y = x[i]/10;
         x[i] %= 10;
     }
     for (;y;y/=10)
         x.push_back(y%10);
 }
 
 ull mod(vector<int> x, ull y)
 {
     ull r = 0;
     for (int i = x.size() - 1; i >= 0; i--)
     {
         r = r*10 + x[i];
         r = r%y;
     }
     return r;
 }
 
 bool enough(int i, vector<int> x)
 {
     int len = 0, tmp = i;
     do {len++; } while (tmp/=10);
     if (2*len < x.size()) return false;
     vector<int> r;
     r.push_back(1);
     mul(r, i);
     mul(r, i);
     if (r.size() > x.size())
         return true;
     if (r.size() < x.size())
         return false;
     for (int i = x.size() - 1; i >= 0; i--)
     {
         if (r[i] > x[i])
             return true;
         if (r[i] < x[i])
             return false;
     }
     return false;
 }
 
 bool prime(vector<int> x, int p)
 {
     for (int i = 2; !enough(i,x); i++)
         if (mod(x, i) == 0)
         {
             ans[p] = i;
             return false;
         }
     return true;
 }
 bool prime(ull x, int p)
 {
     if (x <= 1) return false;
     for (int i = 2; i*i <= x; i++)
         if (x%i == 0)
         {
             ans[p] = i;
             return false;
         }
     return true;
 }
 
 
 ull fun(int b, int d)
 {
     ull x = 1;
     ull ans = 0;
     for (int i = 0; i < d; i++)
     {
         x *= b;
         ans += x;
     }
     x *= b;
     ans = x - ans;
     return ans;
 }
 
 void setNum(ull n)
 {
     vector<int> d;
     for (;n;n/=2) d.push_back(n%2);
     for (int b = 2; b <= 10; b++)
     {
         //ull r = 0;
         vector<int> r;
         r.push_back(0);
         for (int i = d.size() - 1; i >= 0; i--)
         {
             //r = r*b + d[i];
             mul(r,b);
             add(r,d[i]);
         }
         num[b] = r;
         //cout<<r<<" ";
         for (int i=r.size()-1;i>=0;i--)cout<<r[i];cout<<' ';
     }
     cout<<endl;
 }
 
 bool jamcoin(ull n, int d)
 {
     bool ans = true;
     for (int b = 2; b <= 10; b++)
     {
         //num[b] += fun(b, d);
         add(num[b], fun(b, d));
         //cout<<num[b]<<" ";
         //for (int i=num[b].size()-1;i>=0;i--)cout<<num[b][i];cout<<' ';
         if (prime(num[b], b))
             ans = false;
     }
     //cout<<endl;
     return ans;
 }
 
 void print(ull x)
 {
     vector<int> r;
     for (;x;x/=2)
         r.push_back(x%2);
     for (int i=r.size()-1;i>=0;i--)
         printf("%d",r[i]);
 }
 
 ull dif(int x)
 {
     int c = 0;
     while (x%2 == 0)
         x /= 2,
         c++;
     return c;
 }
 
 int main2()
 {
     //freopen("C-small-attempt0.in","r",stdin);
     //freopen("B-large.in","r",stdin);
     //freopen("a.txt","w",stdout);
     scanf("%d", &T);
 	for (int cse = 1; cse <= T; cse++)
 	{
         scanf("%d %d", &n, &j);
         printf("Case #%d:\n", cse);
         int cnt = 0;
         setNum((1<<(n-1))+1);
         for (ull i = (1<<(n-2))+1; cnt < j && i < (1<<(n-1)); i++)
         {
             ull d = dif(i);
             ull x = i<<1|1;
             if (jamcoin(x, d))
             {
                 cnt ++;
                 print(x);
                 for (int i = 2; i <= 10; i++)
                     printf(" %d",ans[i]);
                 printf("\n");
             }
         }
 	}
 	return 0;
 }
 
 
 int k,c,s;
 
 int main()
 {
     //freopen("D-small-attempt0.in","r",stdin);
     freopen("D-large.in","r",stdin);
     freopen("a.txt","w",stdout);
     scanf("%d", &T);
 	for (int cse = 1; cse <= T; cse++)
 	{
         scanf("%d %d %d", &k, &c, &s);
 
         printf("Case #%d:",cse);
         //imp
         if (k + 1 - c > s)
         {
             printf(" IMPOSSIBLE\n");
             continue;
         }
         //c == 1
         if (c == 1)
         {
             printf(" 1\n");
             continue;
         }
         //c >= 2
         for (int n = 1; n <= k; n++)
         {
             ull x = 1;
             ull p = n;
             for (int i = 2; i <= c; i++)
             {
                 x = p*k - k + 1;
                 p = x + n - 1;
                 if (n < k)
                 {
                     n++;
                     p++;
                 }
             }
             printf(" %lld", p);
         }
         printf("\n");
 	}
 	return 0;
 }
