#include<iostream>
 #include<algorithm>
 #include<cmath>
 #include<limits>
 #include<string>
 #include<vector>
 #include<unordered_set>
 #include<map>
 using namespace std;
 
 void permute(int k, string& s, unordered_set<string>& seq){
     for(int j = 1; j < s.size(); ++j) 
     {
         std::swap(s[k % (j + 1)], s[j]); 
         seq.insert(s);
         k = k / (j + 1);
     }
 }
 void permute(string s, int i, int n, unordered_set<string>& seq){
     int j;
     if(i == n){
         seq.insert(s);
     } else {
         for(j = i; j < s.length(); ++j){
             swap(s[i],s[j]);
             if(seq.find(s) == seq.end()){
                 permute(s, i+1, n, seq);
             }
         } 
     }
 }
 
 string upComplexity(string s, string orig){
     string res;
     for(int x = 0; x < s.length(); ++x){
         if(s[x] == 'L'){
             res += orig; 
         } else {
             res += string(orig.length(), 'G');
         }
     }
     return res;
 }
 vector<string> generateStrings(int k, int c){
     vector<string> ret;
     unordered_set<string> seq;
     long numSequencesStart = pow(2,k);
     long val = pow(k, c); 
     string s(k, 'G'); 
     seq.insert(s);
     for(int x = 0; x < k; ++x){
         s[x] = 'L';
         seq.insert(s);
     }
     int end = seq.size();
     for(unordered_set<string>::iterator itr = seq.begin(); itr != seq.end(); ++itr){
         vector<string> r;
         string curr = *itr;
         // permute(curr, 0, curr.length()-1, seq);
         // permute((curr.length()/2), curr, seq);
         do{
             seq.insert(curr);
         } while(next_permutation(curr.begin(), curr.end()));
     }
     unordered_set<string> seq2;
     for(unordered_set<string>::iterator itr = seq.begin(); itr != seq.end(); ++itr){
         string original = *itr;
         string curr = *itr;
         for(int x = 0; x < c-1; ++x){
             curr = upComplexity(curr, original);
         }
         seq2.insert(curr);
     }
     seq = seq2;
     for(auto itr = seq.begin(); itr != seq.end(); ++itr){
         ret.push_back(*itr);
     }
     return ret;
 }
 
 vector<int> findUnique(vector<string> vec){
     vector<int> m(vec[0].length());
     for(int x = 0; x < vec.size(); ++x){
         for(int y = 0; y < vec[x].length(); ++y){
             if(vec[x][y] == 'L'){
                 m[y]++;
             }
         } 
     }
     return m;
 }
 
 void exec(){
     int junk;
     cin >> junk;
     int k, c, s;
     int caseNumber = 1;
     while(cin >> k >> c >> s){
         if(k == s){
             long last = pow(k,c);
             cout << "Case #" << caseNumber << ":";
             while(s > 0){
                 cout <<  " " << last; 
                 --last;
                 --s;
             }
             cout << endl;
             ++caseNumber;
             continue;
         }
         vector<int> unique = findUnique(generateStrings(k,c));
         unordered_set<int> lows;
         while(s > 0){
         int lowest=0;
         int lowVal=numeric_limits<int>::max();
             for(int x = 0; x < unique.size(); ++x){
                 if(unique[x] <= lowVal && lows.find(x+1) == lows.end()){
                     lowVal = unique[x];
                     lowest = x;
                 } 
             }
             lows.insert(lowest+1);
             --s;
         }
         cout << "Case #" << caseNumber << ":";
         for(auto itr = lows.begin(); itr != lows.end(); ++itr){
             cout << " " << *itr;
         }
         cout << endl;
         ++caseNumber;
     }
 }
 
 int main(){
     // vector<string> v = generateStrings(2,3);
     /*
     for(int x = 0; x < v.size(); ++x){
         cout << v[x] << endl; 
     }
     */
     /*
     string test = "LGL";
     string t2 = upComplexity(test,test);
     cout << upComplexity(test, test) << endl;
     cout << upComplexity(t2, test) << endl;
     */
     // findUnique(v);
     // cout << upComplexity("LGL") << endl;
     exec();
 }
