#include <iostream>
 #include <cctype>
 #include <string>
 #include <vector>
 #include <list>
 #include <map>
 #include <algorithm>
 using namespace std;
 
 bool nastyT(size_t X, size_t R, size_t C)
 {
     if (X < 2 * R)
     {
         return false;
     }
 
     size_t base = X - R + 1;
 
     for (size_t i = 0; i <= C - base; ++i)
     {
         if (((base - 2) * (R - 1) + i * R) % X == 0)
             return false;
     }
 
     return true;
 }
 
 class Solve
 {
 public:
     void solve()
     {
         size_t X, R, C;
         cin >> X >> R >> C;
 
         if (R * C % X != 0)
         {
             // Not the right number of squares
             cout << "RICHARD";
             return;
         }
 
         if (C < R) swap(R, C);
 
         if (X >= 2 * R && X != 2)
         {
             // Too long to fit L
             cout << "RICHARD";
             return;
         }
 
         if (X >= 7)
         {
             // A hole in the X-omino
             cout << "RICHARD";
             return;
         }
 
         // Check for a vertical T-shaped object
         if (nastyT(X, R, C))
         {
             cout << "RICHARD";
             return;
         }
 
         cout << "GABRIEL";
     }
 };
 
 int main()
 {
 	size_t n;
 	std::cin >> n;
 	while(std::cin.get() != '\n');
 	for(size_t i=1; i <= n; i++)
 	{
 		std::cout << "Case #" << i << ": ";
         Solve s;
 		s.solve();
 		std::cout << std::endl;
 	}
 }
