#include <iostream>
 #include <vector>
 #include <iterator>
 #include <sstream>
 #include <string>
 #include <cstdlib>
 #include <algorithm>
 using namespace std;
 
 template<typename T, typename IN> vector<T> read_numbers(IN &fin)
 {
     string line;
     getline(fin, line);
     istringstream linestr(line);
 
     vector<T> ret;
     back_insert_iterator< vector<T> > insert_it(ret);
     copy(istream_iterator<T>(linestr),
          istream_iterator<T>(),
          insert_it);
     return ret;
 }
 
 template<typename IN, typename OUT>
 void solve(IN &fin, OUT &fout, int index)
 {
     const auto data = read_numbers<int>(fin);
     const int n = data[0];
     const int x = data[1];
     const int y = data[2];
     bool gabriel =
         (n==1) || (
             (n <= x*y) &&
             ((x*y)%n == 0) &&
             ((1+n)/2 <= min(x, y)) &&
             (n<=x || n<=y) &&
             (n < max(x, y)+1 || n < 4) &&
             (n<7)
         )
     ;
 
 
 
     fout << "Case #" << index << ": " << (gabriel?"GABRIEL":"RICHARD") << endl;
 }
 
 int main()
 {
     const int t = read_numbers<int>(cin).back();  // I know...
     for(int i=0;i<t;++i) {
         solve(cin, cout, i+1);
     }
     return 0;
 }
