#include <iostream>
 
 // As rotations are allowed R & C can be exchanged without changing the result
 // Lets assume then R >= C
 
 // For Richard to win:
 //  R < X (straight line)
 //  2C < X (L shape)
 //  X|R*C
 //  X>=7 (he can choose a shape with hole inside)
 
 // Gabriel allways wins if:
 //  X=1
 //  X=2 & X|R*C
 
 // One cannot cover X=4 C=2 for any R because T shape
 //  will leave 2 more cells on one side than
 //  the other
 // Similar for X=5 C=3 and W shape
 // And for X=6 C=3 and cross shape
 
 // It can be shown by hand that one can cover:
 //  X=3 R=3 C=2 (thus for each (C>=2 & R|3) or C|3)
 //  X=4 R=4 C=3 (thus for each (C>=3 & R|4) or C|4)
 //  X=4 R=6 C=6 (thus for each (R>=6 & R|2 & C>2 & C|2)
 //  X=5 R=5 C=4 (thus for each (C>=4 & R|5) or C|5)
 //  X=6 R=6 C=4 (thus for each (C>=4 & R|6) or C|6)
 //  X=6 R=9 C=4 (thus for each (R|3 & C|2 & C>=4) or (R|2 & C|3 & C>=4))
 
 bool solve(int X, int R, int C)
 {
   if (R < X || 2*C < X || R*C%X != 0 || X >= 7)
     return false;
   switch (X) {
     case 1:
     case 2:
     case 3:
       return true;
     case 4:
       return C > 2;
     case 5:
     case 6:
       return C > 3;
   }
   return false;
 }
 
 int main()
 {
   using namespace std;
   int T;
   cin >> T;
   for (int i = 1; i <= T; ++i)
   {
     int X, R, C;
     cin >> X >> R >> C;
     if (C > R)
       swap(R, C);
     cout << "Case #" << i << ": ";
     if (solve(X, R, C))
       cout << "GABRIEL";
     else
       cout << "RICHARD";
     cout << endl;
   }
 }