#include <cstdio>
 #include <cstring>
 #include <vector>
 #include <queue>
 #include <algorithm>
 using namespace std;
 
 int r, c, n, d;
 long long mn[300][300], mx[300][300];
 bool visit[300][300];
 int di[] = { 0, 1, 0, -1 };
 int dj[] = { 1, 0, -1, 0 };
 
 void proc(int caseidx) {
 	scanf("%d %d %d %d", &r, &c, &n, &d);
 	for (int i = 0; i < r; ++i) for (int j = 0; j < c; ++j) {
 		mn[i][j] = 1;
 		mx[i][j] = 1000000000000ll;
 	}
 
 	bool ok = true;
 
 	for (int i = 0; i < n; ++i) {
 		int si, sj, sb;
 		scanf("%d %d %d", &si, &sj, &sb);
 		--si; --sj;
 
 		mn[si][sj] = max(mn[si][sj], (long long)sb);
 		mx[si][sj] = min(mx[si][sj], (long long)sb);
 		memset(visit, 0, sizeof(visit));
 		if (!ok) continue;
 
 		queue<pair<int, int>> q;
 		q.push({ si, sj });
 		visit[si][sj] = true;
 		while (!q.empty()) {
 			int ci = q.front().first;
 			int cj = q.front().second;
 			q.pop();
 			if (mn[ci][cj] > mx[ci][cj]) {
 				ok = false;
 				break;
 			}
 
 			long long nxtmn = mn[ci][cj] - d;
 			long long nxtmx = mx[ci][cj] + d;
 
 			for (int k = 0; k < 4; ++k) {
 				int ni = ci + di[k], nj = cj + dj[k];
 				if (ni < 0 || ni >= r || nj < 0 || nj >= c) continue;
 
 				mn[ni][nj] = max(mn[ni][nj], nxtmn);
 				mx[ni][nj] = min(mx[ni][nj], nxtmx);
 				if (!visit[ni][nj]) {
 					q.push({ ni, nj });
 					visit[ni][nj] = true;
 				}
 			}
 		}
 	}
 
 	printf("Case #%d: ", caseidx);
 	if (!ok) {
 		printf("IMPOSSIBLE\n");
 	}
 	else {
 		long long ans = 0;
 		for (int i = 0; i < r; ++i) for (int j = 0; j < c; ++j) ans += mx[i][j];
 		printf("%lld\n", ans % 1000000007);
 	}
 	fflush(stdout);
 }
 
 int main() {
 	freopen("input.txt", "r", stdin);
 	freopen("output.txt", "w", stdout);
 	int t;
 	scanf("%d", &t);
 	for (int i = 1; i <= t; ++i) {
 		fprintf(stderr, "%d ", i);
 		proc(i);
 	}
 	return 0;
 }