#include <iostream>
 #include <vector>
 #include <queue>
 using namespace std;
 
 #define MOD 1000000007
 long long int ymax, xmax, n, d;
 
 bool kansu( long long int y, long long int x, long long int k, long long int m[201][201] ) {
 
   if ( y > 0        && m[y-1][x] != 0 && m[y-1][x] > k + d ) return false;
   if ( y < ymax - 1 && m[y+1][x] != 0 && m[y+1][x] > k + d ) return false;
   if ( x > 0        && m[y][x-1] != 0 && m[y][x-1] > k + d ) return false;
   if ( x < xmax - 1 && m[y][x+1] != 0 && m[y][x+1] > k + d ) return false;
 
   return true;
 
 }
 
 int main() {
 
   long long int t;
   cin >> t;
 
   for ( long long int tt = 0; tt < t; tt++ ) {
 
     cout << "Case #" << tt+1 << ": ";
 
 
     cin >> ymax >> xmax >> n >> d;
 
     long long int m[201][201] = {};
     priority_queue< pair< long long int, pair< long long int, long long int > > > q;
     long long int ans = 0;
 
     for ( long long int i = 0; i < n; i++ ) {
       long long int y, x, b;
       cin >> y >> x >> b;
       y--;
       x--;
       m[y][x] = b;
       q.push( make_pair( -b, make_pair( y, x ) ) );
       ans += b;
       ans %= MOD;
     }
 
     bool f = true;
     for ( long long int y = 0; y < ymax; y++ ) {
       for ( long long int x = 0; x < xmax; x++ ) {
 	if ( m[y][x] == 0 ) continue;
 	if ( kansu( y, x, m[y][x], m ) == false ) {
 	  f = false;
 	  break;
 	}
       }
       if ( f == false ) break;
     }
     if ( f == false ) {
       cout << "IMPOSSIBLE" << endl;
       continue;
     }
 
     while( q.size() > 0 ) {
 
       pair< long long int, pair< long long int, long long int > > p = q.top();
       q.pop();
       long long int y = p.second.first;
       long long int x = p.second.second;
       long long int k = -p.first;
 
       k += d;
 
       if ( y > 0 && m[y-1][x] == 0 ) {
 	if ( kansu( y-1, x, k, m ) == false ) {
 	  f = false;
 	  break;
 	}
 	m[y-1][x] = k;
 	ans += k;
 	ans %= MOD;
 	q.push( make_pair( -k, make_pair( y-1, x ) ) );
       }
       if ( y < ymax - 1 && m[y+1][x] == 0 ) {
 	if ( kansu( y+1, x, k, m ) == false ) {
 	  f = false;
 	  break;
 	}
 	m[y+1][x] = k;
 	ans += k;
 	ans %= MOD;
 	q.push( make_pair( -k, make_pair( y+1, x ) ) );
       }
       if ( x > 0 && m[y][x-1] == 0 ) {
 	if ( kansu( y, x-1, k, m ) == false ) {
 	  f = false;
 	  break;
 	}
 	m[y][x-1] = k;
 	ans += k;
 	ans %= MOD;
 	q.push( make_pair( -k, make_pair( y, x-1 ) ) );
       }
       if ( x < xmax - 1 && m[y][x+1] == 0 ) {
 	if ( kansu( y, x+1, k, m ) == false ) {
 	  f = false;
 	  break;
 	}
 	m[y][x+1] = k;
 	ans += k;
 	ans %= MOD;
 	q.push( make_pair( -k, make_pair( y, x+1 ) ) );
       }
 
     }
 
     if ( f == false ) {
       cout << "IMPOSSIBLE" << endl;
     }else {
       cout << ans << endl;
     }
 
   }
 
   return 0;
 
 }
