#include <cstdio>
 #include <iostream>
 #include <cstring>
 #include <cmath>
 using namespace std;
 
 const int MAXN = 55;
 const int INF = 1000000000;
 #define _clr(x) memset(x, 0xff, sizeof(int) * n)
 
 int hungary(int n, int m, const bool mat[][MAXN], int * match1, int * match2) {
     int s[MAXN + 1], t[MAXN], p, q, ret = 0, i, j, k;
     _clr(match1);
     _clr(match2);
     for (i = 0; i < n; ret += (match1[i++] >= 0)) {
         _clr(t);
         for (s[p = q = 0] = i; p <= q && match1[i] < 0; p++) {
             k = s[p];
             for (j = 0; j < m && match1[i] < 0; j++) {
                 if (mat[k][j] && t[j] < 0) {
                     s[++q] = match2[j];
                     t[j] = k;
                     if (s[q] < 0) {
                         for (p = j; p >= 0; j = p) {
                             match2[j] = k = t[j];
                             p = match1[k];
                             match1[k] = j;
                         }
                     }
                 }
             }
         }
     }
     return ret;
 }
 
 void solve() {
 	int n,p;
 	int need[55];
 	int a[55][55];
 	bool mat[MAXN][MAXN];
 
 	scanf("%d%d",&n,&p);
 	for (int i=0;i<n;i++) {
 		scanf("%d",&need[i]);
 	}
 	for (int i=0;i<n;i++) {
 		for (int j=0;j<p;j++) {
 			scanf("%d",&a[i][j]);
 		}
 	}
 
 	if (n==1) {
 		int ans=0;
 		double k1, k2;
 		int t1, t2;
 		for (int j1=0;j1<p;j1++) {
 			//k1 = (double)a[0][j1]/(double)need[0];
 			for (int t1=max( (int)(a[0][j1]/(need[0]*1.1))-1 , 1 );t1<=(int)(a[0][j1]/(need[0]*0.9)+0.5)+1;t1++){
 				if (a[0][j1]<=t1*need[0]*1.1 && a[0][j1]>=t1*need[0]*0.9) {
 					ans++;
 					break;
 				}
 			}
 		}
 		printf("%d\n",ans);
 		return;
 	}
 
 	memset(mat,0,sizeof(mat));
 	double k1, k2;
 	int t1, t2;
 	for (int j1=0;j1<p;j1++) {
 		//k1 = (double)a[0][j1]/(double)need[0];
 		for (int t1=max( (int)(a[0][j1]/(need[0]*1.1))-1 , 1 );t1<=(int)(a[0][j1]/(need[0]*0.9)+0.5)+1;t1++){
 			if (a[0][j1]<=t1*need[0]*1.1 && a[0][j1]>=t1*need[0]*0.9) {
 				//cerr<<j1<<": "<<t1<<endl;
 				for (int j2=0;j2<p;j2++) {
 					//k2 = (double)a[1][j2]/(double)need[1];
 					//cerr<<" "<<a[1][j2]<<","<<t1*need[1]*0.9<<endl;
 					if (a[1][j2]<=t1*need[1]*1.1 && a[1][j2]>=t1*need[1]*0.9) {
 						//cerr<<" "<<j2<<endl;
 						mat[j1][j2] = 1;
 					}
 				}
 			}
 		}
 	}
 
 	int m1[MAXN],m2[MAXN];
 	hungary(n,n,mat,m1,m2);
 	int ans=0;
 	for (int i=0;i<n;i++)
 		if (m1[i]>=0) ans++;
 	printf("%d\n",ans);
 
 }
 
 int main() {
 	int tt;
 	cin>>tt;
 	for (int cs=1;cs<=tt;cs++){
 		printf("Case #%d: ",cs);
 		solve();
 	}
 
 	return 0;
 }