#include <fstream>
 #include <vector>
 
 using namespace std;
 
 const int MAXN = 50, MAXS = MAXN / 3, POWS = (1 << MAXS),
     INF = 1000 * 1000 * 1000 + 5;
 char g[MAXN][MAXN], used[2][MAXN];
 int dp[POWS][MAXN + 1], n;
 
 pair<int, int> dfs(int t, int v) {
     used[t][v] = true;
     int l = 0, r = 0;
     if(t == 0) {
         l++;
         for(int u = 0; u < n; u++)
             if(g[v][u] && !used[t ^ 1][u]) {
                 pair<int, int> p = dfs(t ^ 1, u);
                 l += p.first;
                 r += p.second;
             }
     }
     else {
         r++;
         for(int u = 0; u < n; u++)
             if(g[u][v] && !used[t ^ 1][u]) {
                 pair<int, int> p = dfs(t ^ 1, u);
                 l += p.first;
                 r += p.second;
             }
     }
     return make_pair(l, r);
 }
 
 int main() {
     ifstream in("input.txt");
     ofstream out("output.txt");
     int t;
     in >> t;
     for(int tt = 0; tt < t; tt++) {
         in >> n;
         int ans = 0;
         for(int i = 0; i < n; i++)
             for(int j = 0; j < n; j++) {
                 in >> g[i][j];
                 g[i][j] -= '0';
                 if(g[i][j])
                     ans--;
             }
         for(int i = 0; i < 2; i++)
             for(int j = 0; j < n; j++)
                 used[i][j] = false;
         vector< pair<int, int> > c;
         int cntl = 0, cntr = 0;
         for(int i = 0; i < 2; i++)
             for(int j = 0; j < n; j++)
                 if(!used[i][j]) {
                     pair<int, int> p = dfs(i, j);
                     if(!p.first)
                         cntr++;
                     else if(!p.second)
                         cntl++;
                     else if(p.first == 1 && p.second == 1)
                         ans++;
                     else
                         c.push_back(p);
                 }
         int ans0 = min(cntl, cntr);
         cntl -= ans0;
         cntr -= ans0;
         ans += ans0;
         if(cntr) {
             swap(cntl, cntr);
             for(size_t i = 0; i < c.size(); i++)
                 swap(c[i].first, c[i].second);
         }
         int cs = c.size();
         for(int i = 0; i < (1 << cs); i++)
             for(int j = 0; j <= cntl; j++)
                 dp[i][j] = INF;
         dp[0][cntl] = ans;
         for(int i = 0; i < (1 << cs); i++)
             for(int cnt = 0; cnt <= cntl; cnt++) {
                 if(dp[i][cnt] == INF)
                     continue;
                 int x = (i ^ ((1 << cs) - 1));
                 for(int j = x; j; j = (j - 1) & x) {
                     int l = 0, r = 0;
                     for(int k = 0; k < cs; k++)
                         if(j & (1 << k)) {
                             l += c[k].first;
                             r += c[k].second;
                         }
                     if(l > r)
                         continue;
                     if(r > l + cnt)
                         continue;
                     dp[i | j][cnt - (r - l)] = min(dp[i | j][cnt - (r - l)],
                                                    dp[i][cnt] + r * r);
                 }
             }
         out << "Case #" << tt + 1 << ": " << dp[(1 << cs) - 1][0] << '\n';
     }
     return  0;
 }
