#if 1
 #include <algorithm>
 #include <bitset>
 #include <cassert>
 #include <cmath>
 #include <cstdio>
 #include <cstdlib>
 #include <cstring>
 #include <ctime>
 #include <functional>
 #include <iostream>
 #include <iterator>
 #include <limits>
 #include <list>
 #include <map>
 #include <numeric>
 #include <queue>
 #include <set>
 #include <sstream>
 #include <stack>
 #include <string>
 #include <vector>
 using namespace std;
 
 typedef long long LL;
 typedef long double LD;
 typedef pair<int , int> pii;
 typedef vector <int> veci;
 typedef vector <veci> graph;
 const LD eps = 1e-9;
 const LD pi = acos(-1.0);
 const int inf = 1000 * 1000 * 1000;
 const LL inf64 = LL(inf) * inf;
 
 #define mp make_pair
 #define pb push_back
 #define X first
 #define Y second
 #define iss istringstream
 #define oss ostringstream
 #define dbg(x) {cerr << #x << " = " << x << endl;}
 #define dbgv(x) {cerr << #x << " ={"; for (int _i = 0; _i < x.size(); _i++) {if (_i) cerr << ", "; cerr << x[_i];} cerr << "}" << endl;}
 #define NAME "problem"
 
 template<class T> string to_str(const T &a) { oss os; os << a; return os.str(); }
 template<> string to_str<LD>(const LD& a) { oss os; os.precision(10); os.setf(ios::fixed); os << a; return os.str(); }
 template<class T> T from_str(const string &s) { iss is; T val; is >> val; return val; }
 string T(int test) { ostringstream os; os << "Case #" << test << ":"; return os.str(); }
 int _test_start = -1, _test_end = -1;
 bool need_to_run(int test) { return _test_start == -1 || _test_start <= test && test <= _test_end; }
 const int maxr = 2002;
 int f[102][maxr];
 void upd(int &f, int val)
 {
     if (f == -1 || f < val)
         f = val;
 }
 
 
 void solve(int test)
 {
     // read
     int p, q, n;
     cin >> p >> q >> n;
     vector<int> h(n), g(n);
     for (int i = 0; i < n; ++i)
         cin >> h[i] >> g[i];
 
     if (!need_to_run(test)) return;
     // solve
     memset(f, -1, sizeof f);
     f[0][1] = 0;
     for (int i = 0; i < n; ++i)
         for (int rem = 0; rem < maxr; ++rem)
             if (f[i][rem] != -1)
             {
                 int we_kill = f[i][rem] + g[i];
                 int tower_kill = f[i][rem] + 0;
                 for (int from_rem = 0; from_rem <= rem && from_rem <= 10; ++from_rem)
                 {
                     int cur_health = h[i] - from_rem * p;
                     if (cur_health <= 0)
                     {
                         upd(f[i + 1][rem - from_rem], we_kill);
                         break;
                     }
 
 
                     for (int skip = 0; skip <= 10; ++skip)
                     {
                         int rem_health = cur_health;
                         int max_shots = (rem_health + q - 1) / q;
                         int add_rem = 0;
                         for (int shots = 1; shots <= max_shots; ++shots)
                         {
                             rem_health -= q;
                             if (rem_health <= 0)
                             {
                                 upd(f[i + 1][rem - from_rem + add_rem + 1], tower_kill);
                                 break;
                             } 
                             if (shots > skip)
                             {
                                 rem_health -= p;
                                 if (rem_health <= 0)
                                 {
                                     upd(f[i + 1][rem - from_rem + add_rem], we_kill);
                                     break;
                                 }
                             } else
                                 add_rem++;
                         }
                     }
                 }
                             
             }
 
   
     int res = 0;
 
     for (int j = 0; j < maxr; ++j)
         res = max(res, f[n][j]);
     // write
     cout << T(test) << " " << res << endl;
 }
 
 int main(int argc, char *argv[])
 {
     freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
     //freopen(NAME ".in","r",stdin); freopen(NAME ".out","w",stdout);
     if (argc == 2) { _test_start = _test_end = from_str<int>(argv[1]); }
     if (argc == 3) { _test_start = from_str<int>(argv[1]); _test_end = from_str<int>(argv[2]); }
 
     clock_t tstart = clock();
 
     int tests;
     scanf("%d", &tests);
     for(int test = 1; test <= tests; ++test)
     {
         clock_t tprev = clock();
         solve(test);
         if (need_to_run(test))
             dbg("elapsed for #" << test << ": " << (clock() - tprev) / LD(CLOCKS_PER_SEC));
     }
 
     dbg("elapsed: " << (clock() - tstart) / LD(CLOCKS_PER_SEC));
     return 0;
 }
 /*************************
 *************************/
 #endif
 
