//
 //  main.c
 //  CJ1
 //
 //  Created by LinePlus on 2014. 4. 12..
 //  Copyright (c) 2014년 LINE. All rights reserved.
 //
 
 #include <stdio.h>
 
 #define TABLE_LENGTH 4
 #define FLAG_NOT_FOUND -1
 #define FLAG_FOUND_TWO -2
 
 void retrieveData(FILE *fin, int *row, int data[][TABLE_LENGTH]) {
     fscanf(fin, " %d", row);
     
     for(int i = 0; i < TABLE_LENGTH; i++) {
         for(int j= 0; j < TABLE_LENGTH; j++) {
             fscanf(fin," %d", &data[i][j]);
         }
     }
 }
 
 void game(int round, FILE *fin, FILE *fout) {
     int cards[TABLE_LENGTH][TABLE_LENGTH];
     int candidate[TABLE_LENGTH];
     int row;
     int result = FLAG_NOT_FOUND;
 
     //initialize
     for(int i = 0; i < TABLE_LENGTH; i++) {
         candidate[i] = -1;
         for(int j = 0; j< TABLE_LENGTH; j++) {
             cards[i][j] = -1;
         }
     }
 
     retrieveData(fin, &row, cards);
     
     for(int i = 0; i < TABLE_LENGTH; i++) {
         candidate[i] = cards[row - 1][i];
     }
     
     retrieveData(fin, &row, cards);
     
     for(int i = 0; i < TABLE_LENGTH; i++) {
         for(int j = 0; j < TABLE_LENGTH; j++) {
             if(candidate[i] == cards[row - 1][j]) {
                 if(result == FLAG_NOT_FOUND) {
                     result = candidate[i];
                 }
                 else {
                     result = FLAG_FOUND_TWO;
                     break;
                 }
             }
         }
         if(result == FLAG_FOUND_TWO) {
             break;
         }
     }
     switch (result) {
             case FLAG_NOT_FOUND:
             fprintf(fout, "Case #%d: Volunteer cheated!", round);
             break;
         case FLAG_FOUND_TWO:
             fprintf(fout, "Case #%d: Bad magician!", round);
             break;
         default:
             fprintf(fout, "Case #%d: %d", round, result);
             break;
     }
 }
 
 int main(int argc, const char * argv[])
 {
     FILE *fin = fopen("/Users/lineplus/Documents/projects/CJ1/CJ1/data.in", "r");
     FILE *fout = fopen("/Users/lineplus/Documents/projects/CJ1/CJ1/data.out", "w");
     
     if(fin == NULL || fout == NULL) {
         return -1;
     }
     
     int totalCount = 0;
     fscanf(fin, " %d", &totalCount);
     
     for(int round = 1; round <= totalCount; round++) {
         game(round, fin, fout);
         if(round < totalCount) {
             fprintf(fout, "\n");
         }
     }
     
     fclose(fin);
     fclose(fout);
 
     return 0;
 }
 
