#include <stdio.h>
 
 #define RES_OK	0
 #define RES_BAD 1
 
 int get_row(FILE *f, int *row);
 
 int main(void)
 {
 	FILE *infile, *outfile;
 
 	int res;
 	int case_n, cases;
 	
 	infile = fopen("./in.txt", "r");
 	if (infile == NULL) {
 		printf("Opening in.txt failed\n");
 		return RES_BAD;
 	}
 
 	outfile = fopen("out.txt", "w");
 	if (outfile == NULL) {
 		printf("Opening out.txt failed\n");
 		return RES_BAD;
 	}
 
 	res = fscanf(infile, "%d", &cases);
 	if (res != 1) {
 		printf("Reading from in.txt failed\n");
 		return RES_BAD;
 	}
 
 	printf("We have %d cases\n", cases);
 
 	for (case_n = 1; case_n <= cases; case_n++) {
 		/* Solving */
 		int row1[4] = { 0 };
 		int row2[4] = { 0 };
 		int i, j;
 		int answer = 0;
 		int matches = 0;
 
 		if (get_row(infile, row1) == RES_BAD) {
 			printf("Getting row1 failed\n");
 			return RES_BAD;
 		}
 
 		if (get_row(infile, row2) == RES_BAD) {
 			printf("Getting row2 failed\n");
 			return RES_BAD;
 		}
 
 		for (i = 0; i < 4; i++) {
 			for (j = 0; j < 4; j++) {
 				if (row1[i] == row2[j]) {
 					answer = row1[i];
 					matches++;
 				}
 			}
 		}
 		
 		if (matches == 0)
 			fprintf(outfile, "Case #%d: Volunteer cheated!\n", case_n);
 		else if (matches == 1)
 			fprintf(outfile, "Case #%d: %d\n", case_n, answer);
 		else
 			fprintf(outfile, "Case #%d: Bad magician!\n", case_n);
 	}
 
 	return RES_OK;
 }
 
 int get_row(FILE *f, int *row)
 {
 	int res;
 	int i;
 	int rown;
 	int dump;
 
 	res = fscanf(f, "%d", &rown);
 	if (res != 1) {
 		printf("Reading from in.txt failed\n");
 		return RES_BAD;
 	}
 
 	for(i = 0; i < 16; i++) {
 		if (i / 4 + 1 == rown)
 			res = fscanf(f, "%d", &row[i % 4]);
 		else
 			res = fscanf(f, "%d", &dump);
 
 		if (res != 1) {
 			printf("Reading from in.txt failed\n");
 			return RES_BAD;
 		}
 	}
 
 	return RES_OK;
 }
 
