#include <stdio.h>
 #include <string.h>
 
 void get_row(FILE *fd, int row[4])
 {
 	int nRow;
 	int matrix[4][4];
 
 	fscanf(fd, "%d", &nRow);
 	fscanf(fd, "%d %d %d %d", &matrix[0][0], &matrix[0][1], &matrix[0][2], &matrix[0][3]);
 	fscanf(fd, "%d %d %d %d", &matrix[1][0], &matrix[1][1], &matrix[1][2], &matrix[1][3]);
 	fscanf(fd, "%d %d %d %d", &matrix[2][0], &matrix[2][1], &matrix[2][2], &matrix[2][3]);
 	fscanf(fd, "%d %d %d %d", &matrix[3][0], &matrix[3][1], &matrix[3][2], &matrix[3][3]);
 
 	row[0] = matrix[nRow-1][0];
 	row[1] = matrix[nRow-1][1];
 	row[2] = matrix[nRow-1][2];
 	row[3] = matrix[nRow-1][3];
 }
 
 void calc_result(int row1[4], int row2[4], char *result)
 {
 	int repeated_value = -1;
 	int i, j;
 
 	for (i = 0; i < 4; i++)
 	{
 		for (j = 0; j<4; j++)
 		{
 			if (row1[i] == row2[j])
 			{
 				if (repeated_value != -1)
 				{
 					sprintf(result, "Bad magician!");
 					return;
 				}
 				else
 				{
 					repeated_value = row1[i];
 				}
 			}
 		}
 	}
 
 	if (repeated_value == -1)
 	{
 		sprintf(result, "Volunteer cheated!");
 	}
 	else
 	{
 		sprintf(result, "%d", repeated_value);
 	}
 }
 
 int main(int argc, char const *argv[])
 {
 	FILE *fd;
 	int nTests, i;
 
 	char result[128];
 	int row1[4], row2[4];
 
 	if (argc < 2)
 	{
 		return -1;
 	}
 
 	fd = fopen(argv[1], "r");
 	if (fd == NULL)
 	{
 		return -1;
 	}
 
 	fscanf(fd, "%d", &nTests);
 	for(i=1; i<=nTests; i++)
 	{
 		get_row(fd, row1);
 		get_row(fd, row2);
 		calc_result(row1, row2, result);
 		printf("Case #%d: %s\n", i, result);
 	}
 	fclose(fd);
 	
 
 	return 0;
 }