#include <stdio.h>
 
 // not completely parameterized
 #define ROWSIZE 4
 
 /* 
 parse from stdin.
 store relevant row only.
 better pass array of size ROWSIZE!
 */
 void parse_single(int *row)
 {
 	int i;
 	int rownum;
 	int junk;
 
 
 
 	scanf("%d\n", &rownum);
 	// start counting from zero like a sane person
 	rownum -= 1; 
 
 	for (i = 0; i < rownum; i ++) {
 		// trash these rows
 		scanf("%d %d %d %d\n", &junk, &junk, &junk, &junk);
 	}
 	scanf("%d %d %d %d\n", row, row + 1,
 			row + 2, row + 3);
 
 	for (i = rownum + 1; i < 4; i++) {
 		// trash these rows
 		scanf("%d %d %d %d\n", &junk, &junk, &junk, &junk);
 	}
 }
 
 #define BAD_MAGICIAN 0
 #define VOL_CHEAT 1
 #define FOUNDIT 2
 int solve_single(int *row0, int *row1, int *ret)
 {
 	// hard-coded bitmap for associative array
 	int lut = 0, 
 	    i, 
 	    num_matches = 0;
 
 	for (i = 0; i < ROWSIZE; i++) {
 		lut |= 1 << row0[i];
 	}
 	for (i = 0; i < ROWSIZE; i++) {
 		if (lut & (1 << row1[i])) {
 			if (++num_matches > 1) {
 				return BAD_MAGICIAN;
 			}
 			*ret = row1[i];
 		}
 	}
 	if (num_matches == 1) {
 		return FOUNDIT;
 	} else {
 		return VOL_CHEAT;
 	}
 }
 
 int main()
 {
 	int 	num_inputs,
 		i,
 		row0[ROWSIZE], 
 		row1[ROWSIZE],
 		answer,
 		success_indicator;
 
 	scanf("%d\n", &num_inputs);
 
 	for (i = 0; i < num_inputs; i++) {
 		parse_single(row0);
 		parse_single(row1);
 		success_indicator = solve_single(row0, row1, &answer);
 
 		printf("Case #%d: ", i + 1);
 		if (success_indicator == BAD_MAGICIAN) {
 			printf("Bad magician!\n");
 		} else if (success_indicator == FOUNDIT) {
 			printf("%d\n", answer);
 		} else {
 			printf("Volunteer cheated!\n");
 		}
 	}
 	
 	return 0;
 }
