#include <stdio.h>
 
 void GetCards(int board[4][4], int list[4], int row);
 void ReadBoard(int board[4][4]);
 int PerformTrick(int first[4], int second[4]);
 
 int main()
 {
 	int board[4][4];			// Represents the cards
 	int chosen;					// Card chosen by user
 	int chosen2;				// 2nd ''
 	int caseNum;
 	int sets;					// Number of data sets
 	int first[4];				// Cards in first arrangement
 	int second[4];				// Read in the second arrangement
 	int result;
 
 	// Read in the number of data sets
 	scanf("%d", &sets);
 
 	for (caseNum = 0; caseNum < sets; caseNum++)
 	{
 		// Read in the chosen card
 		scanf("%d", &chosen);
 		chosen--;
 
 		// Read the arrangement the first time
 		ReadBoard(board);
 
 		// Obtain the cards in that row
 		GetCards(board, first, chosen);
 
 		// Read in the chosen card
 		scanf("%d", &chosen2);
 		chosen2--;
 
 		// Read the arrangement the second time
 		ReadBoard(board);
 
 		// Obtain the cards in that row
 		GetCards(board, second, chosen2);
 
 		result = PerformTrick(first, second);
 
 		// Inform user
 		if (result > 0)
 			printf("Case #%d: %d\n", caseNum + 1, result);
 		else
 			printf("Case #%d: %s\n", caseNum + 1, result == 0 ? "Volunteer cheated!" : "Bad magician!");
 	}
 
 	return 0;
 }
 
 // Reads in the arrangement of cards
 void ReadBoard(int board[4][4])
 {
 	int i, j;
 	for (i = 0; i < 4; i++)
 	{
 		for (j = 0; j < 4; j++)
 		{
 			scanf("%d", &board[i][j]);
 		}
 	}
 }
 
 void GetCards(int board[4][4], int list[4], int row)
 {
 	int i;
 	for (i = 0; i < 4; i++)
 		list[i] = board[row][i];
 }
 
 // Returns 0 if player cheated, -1 if multiple choices, else, card number
 int PerformTrick(int first[4], int second[4])
 {
 	int count = 0;
 	int card;
 	int i, j;
 
 	for (i = 0; i < 4; i++)
 	{
 		for (j = 0; j < 4; j++)
 		{
 			if (first[i] == second[j])
 			{
 				card = first[i];
 				count++;
 			}
 		}
 	}
 
 	if (count > 1)
 		return -1;
 	else if (count == 0)
 		return 0;
 	else
 		return card;
 }