#include <cstdlib>
 #include <cmath>
 #include <climits>
 #include <cfloat>
 #include <map>
 #include <utility>
 #include <set>
 #include <iostream>
 #include <memory>
 #include <string>
 #include <vector>
 #include <algorithm>
 #include <functional>
 #include <sstream>
 #include <deque>
 #include <complex>
 #include <stack>
 #include <queue>
 #include <cstdio>
 #include <cctype>
 #include <cstring>
 #include <ctime>
 #include <iterator>
 #include <bitset>
 #include <numeric>
 #include <list>
 #include <iomanip>
 #include <cassert>
 
 #if __cplusplus >= 201103L
 #include <array>
 #include <tuple>
 #include <initializer_list>
 #include <unordered_set>
 #include <unordered_map>
 #include <forward_list>
 
 #define cauto const auto&
 #endif
 
 using namespace std;
 
 
 namespace{
 
 typedef long long LL;
 typedef pair<int,int> pii;
 typedef pair<LL,LL> pll;
 
 typedef vector<int> vint;
 typedef vector<vector<int> > vvint;
 typedef vector<long long> vll, vLL;
 typedef vector<vector<long long> > vvll, vvLL;
 
 #define VV(T) vector<vector< T > >
 
 template <class T>
 void initvv(vector<vector<T> > &v, int a, int b, const T &t = T()){
 	v.assign(a, vector<T>(b, t));
 }
 
 template <class F, class T>
 void convert(const F &f, T &t){
 	stringstream ss;
 	ss << f;
 	ss >> t;
 }
 
 
 #define REP(i,n) for(int i=0;i<int(n);++i)
 #define ALL(v) (v).begin(),(v).end()
 #define RALL(v) (v).rbegin(),(v).rend()
 #define PB push_back
 
 
 #define MOD 1000000009LL
 #define EPS 1e-8
 
 
 const LL INF = LLONG_MAX / 9;
 
 void prepare(){
 	
 }
 
 LL calc(const vll &m, LL t){
 	LL c = 0;
 	for(LL x : m){
 		c = min(c + t / x + 1, INF);
 	}
 	return c;
 }
 
 LL solve(){
 	int b;
 	LL n;
 	cin >> b >> n;
 	vll m(b);
 	for(int i = 0; i < b; ++i){
 		cin >> m[i];
 	}
 	
 	if(n <= b){ return n; }
 	
 	LL lt = 0, rt = INF;
 	while(lt + 1 < rt){
 		LL mid = (lt + rt) >> 1;
 		LL c = calc(m, mid);
 		if(c >= n){
 			rt = mid;
 		}
 		else{
 			lt = mid;
 		}
 	}
 
 	LL t = n - calc(m, lt);
 	assert(t > 0);
 	for(int i = 0; i < b; ++i){
 		if(rt % m[i] == 0 && !--t){
 			return i + 1;
 		}
 	}
 	abort();
 }
 
 
 }
 int main(){
 	cout << fixed << setprecision(15);
 	cerr << fixed << setprecision(6);
 	prepare();
 
 	int T = 0;
 	cin >> T;
 	for(int cnum = 1; cnum <= T; ++cnum){
 		fprintf(stderr, "%4d / %d\n", cnum, T);
 		cout << "Case #" << cnum << ": " << flush;
 		auto ans = solve();
 		cout << ans << endl;
 	}
 }
