#include <iostream>
 #include <fstream>
 #include <cstdio>
 #include <set>
 #include <vector>
 #include <algorithm>
 #include <cmath>
 #include <cstdlib>
 #include <string>
 
 using namespace std;
 
 int n;
 long long l;
 int b[110];
 
 void Load()
 {
 	cin >> l >> n;
 	int i;
 	for (i = 0; i < n; i++)
 	{
 		scanf("%d", &b[i]);
 	}
 }
 
 class Vertex
 {
 public:
 	int id;
 };
 
 int dst[110000];
 long long len[110000];
 
 bool operator<(const Vertex &a, const Vertex &b)
 {
 	if (dst[a.id] < dst[b.id]) return true;
 	if (dst[a.id] > dst[b.id]) return false;
 	if (len[a.id] > len[b.id]) return true;
 	if (len[a.id] < len[b.id]) return false;
 	return a.id < b.id;
 }
 
 long long Solve(int blen)
 {
 	int i;
 	for (i = 0; i < blen; i++) 
 	{
 		dst[i] = 0x7F7F7F7F;
 		len[i] = 0;
 	}
 	dst[0] = 0;
 	len[0] = 0;
 	Vertex a;
 	a.id = 0;
 	set<Vertex> v;
 	v.insert(a);
 	while (v.size() > 0)
 	{
 		a = *v.begin();
 		v.erase(v.begin());
 		//cerr << "At vertex " << a.id << " dst = " << dst[a.id] << " len = " << len[a.id] << "\n";
 		int i;
 		for (i = 0; i < n; i++)
 		{
 			Vertex nv;
 			nv.id = (a.id + b[i]) % blen;
 			//cerr << "Trying to go to " << nv.id << "\n";
 			if (dst[nv.id] > dst[a.id] + 1 ||
 			    ((dst[nv.id] == dst[a.id] + 1) && (len[nv.id] < len[a.id] + b[i])) )
 			{
 				v.erase(nv);
 				dst[nv.id] = dst[a.id] + 1;
 				len[nv.id] = len[a.id] + b[i];
 				v.insert(nv);
 			}
 		}
 	}
 	if (dst[l % blen] == 0x7f7F7F7F) return -1;
 	if (len[l % blen] > l) cerr << "B0TVA!!!";
 	long long cres = dst[l % blen] + (l - len[l % blen]) / blen;
 	return cres;
 }
 
 void Solve()
 {
 	int i;
 	long long ans = -1;
 	sort(b, b + n);
 	reverse(b, b + n);
 	for (i = 0; i < n; i++)
 	{
 		long long cans = Solve(b[i]);
 		if (cans == -1) continue;
 		if (ans == -1 || cans < ans) ans = cans;
 	}
 	//int d = 0;
 	//for (i = 0; i < n; i++) d = __gcd(d, b[i]);
 	//if (l % d != 0)  cout << "REALLY ";
 //	long long cans = Solve2();
 //	if (cans != -1 && (ans == -1 || ans > cans)) ans = cans;
 	if (ans == -1) printf("IMPOSSIBLE");
 	else cout << ans;
 }
 
 int main()
 {
 	freopen("input.txt", "rt", stdin);
 	freopen("output.txt", "wt", stdout);
 	int nt, it;
 	scanf("%d", &nt);
 	for (it = 0; it < nt; it++)
 	{
 		printf("Case #%d: ", it + 1);
 		cerr << it << "\n";
 		Load();
 		Solve();
 		printf("\n");
 	}
 	return 0;
 }